!     the file hpg_mossbauer.f containes the following subroutines:        
!     subroutine moss_plot(cmch)                                       
!     subroutine drive(mode_drive,nonlinear,nchansp, &
!                is also used by fr_strobmoss.f                        
!     subroutine geometry(ichansp,cosa,a_R,jt)                         
!     subroutine moss_selsubspect(text)                                
!     subroutine moss_selsubtract(text,isub)                           
!     subroutine moss_subspect(cmch,mi,isub,info)                      
!     subroutine moss_subtract(cmch,mi,isub,info)                      
!     subroutine mosstrans_mcarlo(nu_channel)                          

     subroutine moss_plot(cmch) 
     use glbconst, only: maxn,max8,maxsub,infplot,MDBPLFT,    &
                         icstrf,ivstrf
     use comdat, only: file_data,name_data,formdata,b_data,b_theory,   &
                       name_theory,ichanks,mxpt,mfpt,mdfpt
     use complt, only: display_mode,ndisplay_mode,n_subset,icolor_sub
     use comthe, only: real_fr,thfk
     implicit none  
     character(len=4),intent(in)::  cmch 
                                                                       
     integer      n_subspectra,logx,logy,logf,         &
                  int3d,npnt3d,ifeder,ltext,npntplot,nchanplot,ncolor  
     real         xyzdz,vtxt,vtxtp,parray                              

     character(len=132):: plotstrpu,title
     character(len=24) :: axesname,abscissa,bgcolor,fgcolor,   &  
                          datacolor,thcolor,rescolor,auxcolor1,         & 
                          auxcolor2,auxcolor3
     character(len=80) :: datfile,plotstrdef,ordinata
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,ch4d, ch4de
     real              :: datx,errx,sym,subspectrum,varray,yarray,yyarray, &
                          v1array,v3array,vrarray,vdarray,resarray
     integer           :: irarray,i0array,i1array,i2array                  
     logical           :: b_datf
     integer,parameter :: max8subn=maxsub*max8,max4=4*maxn,         &
                          maxn0=4*maxn+2,maxnh=4*maxn/2,            &
                 idumpl=4*maxn-8*39-5*infplot-maxsub-188,           & 
                 jdumpl=8*maxn0+4*maxnh+max4,                       &
                 kdumpl=3*max4+max4*maxsub,                         &
                 ldumpl=MDBPLFT*2-144*maxn-jdumpl-kdumpl
     common/plot/parray(maxn*112),xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32), &
                 int3d(maxn*16),npnt3d(16),ifeder(maxn*4),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 bgcolor,fgcolor,datacolor,thcolor,rescolor,           &
                 auxcolor1,auxcolor2,auxcolor3,datfile,ch4d(idumpl),   &
                 varray(maxn0),yarray(maxn0),yyarray(maxn0),           &
                 v1array(maxn0),v3array(maxn0),vrarray(maxn0),         &
                 vdarray(maxn0),resarray(maxn0),irarray(maxnh),        &
                 i0array(maxnh),i1array(maxnh),i2array(maxnh),         &
                 b_datf(max4),datx(max4),errx(max4),sym(max4),         &
                 subspectrum(max4,maxsub),ch4de(ldumpl) 

!    common/plot/parray(maxn*144+jdumpl),datx(max4),errx(max4),sym(max4),
!                subspectrum(max4,maxsub),ch4de(ldumpl)
                                                                       
     real,dimension(max8):: plotx,ploty,ploterry,plotres,plotxx,plotyy
     real,dimension(max4):: plotdvcorr
     real,dimension(max8subn):: plotsub
     equivalence (parray(1),plotx(1)),(parray(max8+1),ploty(1)),       &
                 (parray(max8*2+1),ploterry(1)),                       &
                 (parray(max8*3+1),plotres(1)),                        &
                 (parray(max8*4+1),plotxx(1)),                         &
                 (parray(max8*5+1),plotyy(1)),                         &
                 (parray(max8*6+1),plotsub(1)),                        &
                 (parray(max8*13+max4+1),plotdvcorr(1))
                        
     real          dum1,channels,dum2,drive_mode,channels_vmax,dumcs
     common/acstrf/dum1(5),channels,dum2(3),drive_mode,channels_vmax,  &
                   dumcs(icstrf-11)

     real          avsp,f_factor,base,bg_fraction,v_max,channel_v0,dumvs
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,    &
                   dumvs(ivstrf-6)

                   
     integer       idum,mvpt,mgpt,ifrth
     common/strLOC/idum(3),mvpt,mgpt,ifrth(27)

     logical         b_logx,b_logy,b_vdarray,b_velocityscale
     character(len=1) :: chx,chbx,chlr,chy,chby,chbt,ch0 
     character(len=80):: CTEXT,CXTEXT,CYTEXT
     character(len=24):: frcolor
     character(len=9) :: chsub
     integer         nformx,nformy,i,ii,il,ir,irh,is1,is2,i0,il0,     &
                     il1,il2,ivd,l,k,nbegin,nchansp,nend,nh,nresidue, &
                     j,ns,nsinglev,ny,nyy,iofs
     real            chh,chw,syw,syh,aa,base2,basepl,bb,ff,det,glow,  &
                     fold_point,sqrt2,v1,v1mv3,v3,vil,vil1,vil2,vir,  &
                     vr,xmax,xmin,y1,y2,y3,ymin,ymax,hd,hmin,hmax,    &
                     resmin,resmax,ressum 
     real, dimension(:), allocatable :: velocity,geof 


      ch0=char(0) 
      i0=ichar('0') 
      if(cmch.eq.'dstr') then 
!      the string formdata also defines the sequence of storage of 
!      the y-, dy- (error of y), and x-data on the array real_fr().
!      y,dy is always stored (if dy is not on the data file dy=sqrt(y)) 
       formdata(1)='y' 
       formdata(2)='y,x'
       formdata(3)='y,dy' 
       formdata(4)='y,dy,x' 
       formdata(5)=' '               ! defines end
       return 
      end if 
      if(cmch.eq.'dmod') then 
       display_mode(1)='channel scale, counts' 
       display_mode(2)='channel scale, counts, residual spectrum' 
       display_mode(3)='velocity scale' 
       display_mode(4)='velocity scale, residual spectrum' 
       display_mode(5)='velocity scale, counts' 
       display_mode(6)='velocity scale, counts, residual spectrum' 
       display_mode(7)='channel scale & correction function ' 
       display_mode(8)=' ' 
       namechan(1)='x' 
       namechan(2)='y' 
       namechan(3)='dy' 
       namechan(4)='res' 
       namechan(5)='xt' 
       namechan(6)='yt' 
       namechan(7)='su' 
       namechan(8)=' '               ! defines end
       plotstrdef='(x,y,dy)' 
       if(b_theory)then 
        plotstrdef='(x,y,dy) (xt,yt)' 
        j=21 
        if(ndisplay_mode.eq.2.or.ndisplay_mode.eq.4                     &
                             .or.ndisplay_mode.eq.6)then              
         plotstrdef='(x,y,dy) (xt,yt) (x,res)' 
         j=30 
        end if 
        if(n_subset.gt.0)then 
         do i=1,n_subset 
          chsub=' (xt,su'//char(i+i0)//')' 
          k=j+(i-1)*9 
          plotstrdef(k:)=chsub 
         end do 
        end if 
       end if 
       return 
      end if 
                                                                        
      if(ndisplay_mode.eq.3.or.ndisplay_mode.eq.4) then 
       kform(1)='f6.2' 
       kform(2)='f10.6' 
       kform(3)='f10.6' 
       kform(4)='f10.6' 
       kform(5)='f6.2' 
       kform(6)='f10.6' 
       kform(7)='f10.6' 
       nformy=2 
      else if(ndisplay_mode.le.2.or.ndisplay_mode.ge.5) then 
       kform(1)='f8.3,2x' 
       kform(2)='f12.2,2x' 
       kform(3)='f8.1,2x' 
       kform(4)='f12.1,2x' 
       kform(5)='f8.3,2x' 
       kform(6)='f12.0,2x' 
       kform(7)='f12.0,2x' 
       nformy=0 
      end if 
      kform(8)=' ' 
                                                                        
   select case(ndisplay_mode)     
     case(1)
!      display_mode(3)='channel scale'                                 
       abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
     case(2)
!      display_mode(4)='-channel scale, residual spectrum'             
       abscissa='channel' 
       ordinata='counts' 
       axisformat(1)='%6.0f ' 
       axisformat(2)='%8.0f ' 
       nformx=0 
     case(3)
!      display_mode(1)='velocity scale'                                
       abscissa='mm/s' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
     case(4)
!      display_mode(2)='-velocity scale, residual spectrum'            
       abscissa='mm/s' 
       ordinata='relative transmission' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=1 
     case(5,6)
!      display_mode(5,6)='-velocity scale, counts, residual spectrum'   
       abscissa='mm/s' 
       ordinata='counts' 
       axisformat(1)='%8.2f ' 
       axisformat(2)='%10.2f ' 
       nformx=0 
     case(7)
!      display_mode(7)='channel scale & correction function'
       abscissa='channel' 
       ordinata= 'velocity correction dv' 
       axisformat(1)='%6.2f ' 
       axisformat(2)='%6.2f ' 
       nformx=0 
   end select
       b_velocityscale=ndisplay_mode.ge.3.and.ndisplay_mode.le.6
       nresidue=1
       if(ndisplay_mode.eq.1.or.ndisplay_mode.eq.3.or.ndisplay_mode.eq.5) nresidue=0 
       if(.not.b_data) title=name_theory 
       if(base.eq.0.) base=1. 
       n_subspectra=0 
       if(b_theory) n_subspectra=n_subset 
       nchansp=channels 
       fold_point=channel_v0+channels_vmax 

      bgcolor='LightYellow'//ch0 
      fgcolor='black'//ch0 
      datacolor=fgcolor 
      thcolor=fgcolor 
      rescolor='blue'//ch0 
      do j=1,maxsub 
       ncolor(j)=icolor_sub(j) 
      end do 
      axesname(1)=abscissa 
      axesname(2)=ordinata 
      axesname(3)=' ' 
      title=name_data
      ii=index(file_data,'.') 
      if(ii.eq.0) then 
       datfile='Ptheory_nodata.ps'//char(0) 
      else 
       datfile='P'//file_data(1:ii)//'ps'//char(0) 
      end if 
!     write(6,'(2a)')'datfile=',datfile(1:60)                          

!      write(6,'(a,i4)') ' *****moss_plot*********'                     
!       write(6,'(2(a,l5),a,i5)') ' b_data=',b_data,                    
!     &  '  b_theory=',b_theory,' n_subspectra=',n_subspectra           
!       write(6,'(4(a,f10.3))') ' base=',base,'  geo=',geo,             
!     &         '  fold=',fold_point,'  fresonant=',fresonant           
!     if(b_theory) then                                                 
!      write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)                     
!     else                                                              
!      write(6,'(20L4)') (b_datf(j),j=1,nchansp,16)                     
!     end if                                                            
                                                                        
      do j=1,nchansp 
       b_datf(j)=.false. 
      end do 
      do k=2,ichanks(0),2 
       do j=ichanks(k-1),ichanks(k) 
        b_datf(j)=.true. 
       end do 
      end do 
                                                                        
      if (.not.allocated(velocity))allocate(velocity(nchansp),geof(nchansp))

      if(b_theory) then
       do i=1,nchansp
        velocity(i)=real_fr(mvpt+i)
        geof(i)=real_fr(mgpt+i)
        plotdvcorr(i)=real_fr(mxpt+i)        
       end do
      else
       do i=1,nchansp
        velocity(i)=real_fr(mvpt+i)
        geof(i)=1.
       end do
      end if
      ny=0 
      nyy=0 
      nchanplot=0     ! array

      basepl=base 
      if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6) basepl=1 
                                                                        
     if(b_data) then 
        nbegin=0 
        i=0 
        do while(nbegin.eq.0.and.i.lt.nchansp) 
         i=i+1 
         if(b_datf(i)) nbegin=i 
        end do 
        nend=0 
        i=nchansp+1 
        do while(nend.eq.0.and.i.gt.1) 
         i=i-1 
         if(b_datf(i)) nend=i 
        end do 
        do i=1,nchansp 
         varray(i)=velocity(i) 
        end do 
        varray(nchansp+1)=varray(1) 
        varray(nchansp+2)=varray(2) 

        iofs=1
        if(drive_mode.eq.2) iofs=10

        nsinglev=1                              ! double/full  spectrum 
        if(nend*0.9.lt.fold_point) nsinglev=-1  ! single/half  spectrum 

        basepl=base 
        if(ndisplay_mode.eq.5.or.ndisplay_mode.eq.6)then 
         basepl=1 
         if(nsinglev.eq.1)basepl=0.5 
        end if 
                                                                        
!        write(6,'(a,2i6)') ' ndisplay_mode=',ndisplay_mode,nchansp     
!        write(6,'(3(a,i7))')' mfpt=',mfpt,' mdfpt=',mdfpt,' sigle_v=',nsinglev

        b_vdarray=.false. 
        if(b_velocityscale) then 
                                                                        
         if(nsinglev.lt.0) then 
          do ii=nbegin,nend 
           if(b_datf(ii)) then 
            ny=ny+1 
            plotx(ny)=velocity(ii) 
            ploty(ny)=real_fr(mfpt+ii)/basepl 
            ploterry(ny)=real_fr(mdfpt+ii)/basepl 
           end if 
          end do 
                                                                        
          if(b_theory) then 
           do ii=nbegin,nend 
            nyy=nyy+1 
            plotxx(nyy)=velocity(ii) 
            plotyy(nyy)=thfk(ii)/basepl 
           end do 
                                                           
           if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6) then 
            ressum=0.0
            ns=0 
            do ii=nbegin,nend 
             if(b_datf(ii)) then 
              ns=ns+1 
              plotres(ns)=ploty(ii)-plotyy(ii)
              ressum=ressum+plotres(ns)
             end if 
            end do 
            ressum=ressum/float(ns)
           end if 

           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j)/basepl 
             end do 
            end do 
           end if 
          end if  ! b_theory  
          goto 200 
         end if  !  nsinglev < 0  
                                                                        
         sqrt2=sqrt(2.) 
         base2=2*basepl 
                                                                        
         l=3*int(log10(abs(v_max/nchansp*4.))*2.) 
         glow=10**l 
!        write(6,'(a,i4)') ' lower limit =',l                           
         if(b_theory) then 
          do i=1,nchansp 
           yyarray(i)=thfk(i)/geof(i) 
          end do 
          yyarray(nchansp+1)=thfk(1)/geof(1) 
          yyarray(nchansp+2)=thfk(2)/geof(2) 
         end if 
                                                                        
         do i=1,nchansp 
          resarray(i)=real_fr(mfpt+i)-thfk(i) 
          yarray(i)=real_fr(mfpt+i)/geof(i) 
         end do 
         yarray(nchansp+1)=real_fr(mfpt+1)/geof(1) 
         yarray(nchansp+2)=real_fr(mfpt+2)/geof(2) 

         nh=nchansp/2. 
         irh=int(fold_point)+1 
         il=irh 
         do ii=irh,irh+nh-1 
          ir=ii 
          if(ir.gt.nchansp) ir=ir-nchansp 
          il=il+1 
          il1=il+1 
          vir=varray(ir) 
          vil=varray(il) 
          vil1=varray(il1) 
          ivd=1 
          do while(ivd.gt.0) 
           il2=il1 
           il1=il 
           vil2=vil1 
           vil1=vil 
           ivd=1 
           if(vil2-vir.le.0)  ivd=-1 
           if(vil2-vir.eq.0) goto 18 
           if(vil1-vir.lt.0) then 
            ivd=-ivd 
           else if(vil1-vir.eq.0) then 
            ivd=-1 
           end if 
  18       il=il-1 
           if(il.lt.1) il=il+nchansp 
           vil=varray(il) 
          end do 

          v1=vil-vil1 
          v3=vil2-vil1 
          vr=vir-vil1 
          if(b_theory) then 
           nyy=nyy+1 
           irarray(nyy)=ir 
           i0array(nyy)=il 
           i1array(nyy)=il1 
           i2array(nyy)=il2 
           v1array(nyy)=v1 
           v3array(nyy)=v3 
           vrarray(nyy)=vr 
           vdarray(nyy)=0. 
                                                                        
           v1mv3=v1-v3 
           det=v1*v3*v1mv3 
           if(abs(det).gt.glow) then 
            vdarray(nyy)=det 
            b_vdarray=.true. 
            y1=yyarray(il) 
            y2=yyarray(il1) 
            y3=yyarray(il2) 
            y1=y1-y2 
            y3=y3-y2 
            y1=y1*v3  
            y3=y3*v1 
            aa=y1-y3 
            bb=-y1*v3+y3*v1 
            ff=vr*(vr*aa+bb)/det+y2 
           else 
            ff=yyarray(il1) 
            b_vdarray=.false. 
           end if 
           plotxx(nyy)=vir 
           plotyy(nyy)=(yyarray(ir)+ff)/base2 
          else 
           b_vdarray=.false. 
          end if  ! b_theory   
                                                                        
          if(b_datf(ir)) then 
           y1=yarray(il) 
           y2=yarray(il1) 
           y3=yarray(il2) 
           if(y1.ne.0..and.y2.ne.0..and.y3.ne.0.) then 
            ny=ny+1 
            if(b_vdarray) then 
             ff=(y1+y2+y3)/3.
            else 
             ff=y2 
            end if 
            plotx(ny)=vir 
            ploty(ny)=(yarray(ir)+ff)/base2 
            ploterry(ny)=sqrt2*real_fr(mdfpt+ir)/base2 
            if(ndisplay_mode.eq.4.or.ndisplay_mode.eq.6)                &
                              plotres(ny)=resarray(ir)/base2           
           end if 
          end if 
         end do 
                                                                
!        ny plot points for the data                                    
!        nyy plot points for the theory                                 
         ns=0                                                               
         if(b_theory.and.n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           do i=1,nchansp 
            yyarray(i)=subspectrum(i,j) 
           end do 
           yyarray(nchansp+1)=yyarray(1) 
           yyarray(nchansp+2)=yyarray(2) 
                                                                        
           ns=(j-1)*max8 
           nchanplot(6+j)=nh 
           do ii=1,nh 
            v1=v1array(ii) 
            v3=v3array(ii) 
            vr=vrarray(ii) 
            det=vdarray(ii) 
            ir=irarray(ii) 
            il0=i0array(ii) 
            il1=i1array(ii) 
            il2=i2array(ii) 
            if(det.ne.0.) then 
             y1=yyarray(il0) 
             y2=yyarray(il1) 
             y3=yyarray(il2) 
             y1=y1-y2 
             y3=y3-y2 
             y1=y1*v3 
             y3=y3*v1 
             aa=y1-y3 
             bb=-y1*v3+y3*v1 
             ff=vr*(vr*aa+bb)/det+y2 
            else 
             ff=yyarray(il1) 
            end if 
            ns=ns+1 
            plotsub(ns)=(subspectrum(ir,j)+ff)/base2 
           end do 
          end do 
         end if 
        else      ! ndisplay_mode: b_velocityscale=true 
         if(ndisplay_mode.eq.7)then
          do i=nbegin,nend 
           if(b_datf(i)) then 
            ny=ny+1 
            plotx(ny)=i 
            ploty(ny)=real_fr(mfpt+i)/basepl 
            ploterry(ny)=real_fr(mdfpt+i)/basepl 
           end if 
          end do 
          if(b_theory) then 
!           do i=nbegin,nend                                             
           do i=1,nchansp 
            nyy=nyy+1 
            plotxx(nyy)=i 
            plotyy(nyy)=thfk(i)/basepl 
            plotdvcorr(nyy)=real_fr(mxpt+i)        
           end do 
           ressum=0.0
           ns=0 
           do ii=nbegin,nend 
            if(b_datf(ii)) then 
             ns=ns+1 
             plotres(ns)=(real_fr(mfpt+ii)-thfk(ii))/basepl 
             ressum=ressum+plotres(ns)
            end if 
           end do 
           ressum=ressum/float(ns)
           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j)/basepl  
             end do 
            end do 
           end if 
          end if  ! b_theory 
         else   ! ndisplay_mode.eq.7
          do i=nbegin,nend 
           if(b_datf(i)) then 
            ny=ny+1 
            plotx(ny)=i 
            ploty(ny)=real_fr(mfpt+i) 
            ploterry(ny)=real_fr(mdfpt+i) 
           end if 
          end do 
          if(b_theory) then 
!           do i=nbegin,nend                                             
           do i=1,nchansp 
            nyy=nyy+1 
            plotyy(nyy)=thfk(i) 
            plotxx(nyy)=i 
            plotdvcorr(nyy)=real_fr(mxpt+i)        
           end do 
           if(ndisplay_mode.eq.2) then 
            ressum=0.0
            ns=0 
            do ii=nbegin,nend 
             if(b_datf(ii)) then 
              ns=ns+1 
              plotres(ns)=real_fr(mfpt+ii)-thfk(ii) 
              ressum=ressum+plotres(ns)
             end if 
            end do 
            ressum=ressum/float(ns)
           end if 
           if(n_subspectra.gt.0) then 
            do j=1,n_subspectra 
             ns=(j-1)*max8 
             nchanplot(6+j)=nend-nbegin+1 
             do ii=1,nchansp 
              ns=ns+1 
              plotsub(ns)=subspectrum(ii,j) 
             end do 
            end do 
           end if 
          end if  ! b_theory 
         end if
        end if   ! ndisplay_mode.ge.3  
     else      ! b_data   
                                                                        
        if(b_velocityscale) then
         is1=sign(1.,velocity(3)-velocity(1))
         do ii=1,nchansp-3
         is2=is1*sign(1.,velocity(ii+3)-velocity(ii)) 
          if(is2.lt.0) goto 19 
         end do
 19      continue

         nyy=nchansp/2
         if(ii.gt.nchansp-3) nyy=nchansp

         do i=1,nyy 
          plotxx(i)=velocity(i) 
          plotyy(i)=thfk(i)/basepl/geof(i) 
         end do 
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j)/basepl/geof(i) 
           end do 
          end do 
         end if 
        else 
         nyy=nchansp 
         do i=1,nchansp 
          plotxx(i)=nyy-i+1 
          plotyy(i)=thfk(i) 
         end do 
         ns=0
         if(n_subspectra.gt.0) then 
          do j=1,n_subspectra 
           ns=(j-1)*max8 
           nchanplot(6+j)=nyy 
           do i=1,nyy 
            plotsub(ns+i)=subspectrum(i,j) 
           end do 
          end do 
         end if 
        end if 
     end if  ! b_data  
                                                                        
  200 continue 
                                                                        
      xmin=1.e30 
      xmax=-xmin 
      ymin=xmin 
      ymax=0.      ! counts > 0  
      if(b_data) then 
       do ii=1,3 
        nchanplot(ii)=ny 
       end do 
       if(xmin.gt.plotx(1))xmin=plotx(1) 
       if(xmax.lt.plotx(ny))xmax=plotx(ny) 
       if(xmin.gt.plotx(ny))xmin=plotx(ny) 
       if(xmax.lt.plotx(1))xmax=plotx(1) 
       do i=1,ny 
        if(ymin.gt.ploty(i)-ploterry(i))ymin=ploty(i)-ploterry(i) 
       end do 
       do i=1,ny 
        if(ymax.lt.ploty(i)+ploterry(i))ymax=ploty(i)+ploterry(i) 
       end do 
      end if 
      if(b_theory) then 
       nchanplot(5)=nyy 
       nchanplot(6)=nyy 
       if(xmin.gt.plotxx(1))xmin=plotxx(1) 
       if(xmax.lt.plotxx(nyy))xmax=plotxx(nyy) 
       if(xmin.gt.plotxx(nyy))xmin=plotxx(nyy) 
       if(xmax.lt.plotxx(1))xmax=plotxx(1) 

       do i=1,nyy 
        if(ymin.gt.plotyy(i))ymin=plotyy(i) 
       end do 
       do i=1,nyy 
        if(ymax.lt.plotyy(i))ymax=plotyy(i) 
       end do 
      end if 

      if(ndisplay_mode.eq.7) then
       hmax=-1.0e10
       hmin=-hmax
       do i=1,nyy 
        if(hmin.gt.plotdvcorr(i))hmin=plotdvcorr(i) 
       end do 
       do i=1,nyy 
        if(hmax.lt.plotdvcorr(i))hmax=plotdvcorr(i) 
       end do
       if(hmax.gt.0.3)hmax=0.3;  if(hmin.lt.-0.3)hmin=-0.3
       vr=ymin-2*hmax+hmin
       i=vr*10. +1
       ymin=float(i)/10.
       if(ymin.gt.0.7)ymin=0.7
       i=(ymin-hmin)*10 +1
       vr=float(i)/10.
       plotdvcorr(1)=vr

       nchanplot(infplot)=2
       do i=2,nyy 
        plotdvcorr(i)=plotdvcorr(i)+vr
       end do 
      end if

      if(nresidue.eq.1.and.b_theory) then 
        nchanplot(4)=ny 
        resmin=0. 
        resmax=0. 
        do i=1,ny 
         hd= plotres(i)-ploterry(i) 
         if(resmin.gt.hd) resmin=hd 
        end do 
        do i=1,ny 
         hd= plotres(i)+ploterry(i) 
         if(resmax.lt.hd) resmax=hd 
        end do 
         hd= resmax-2.0*resmin 
        do i=1,ny 
         plotres(i)=plotres(i)+ymax-resmin 
        end do 
        ymax=ymax-resmin+resmax 
!        print '(a,f10.1)',' average <exp-theo>=',ressum
      end if 

       xyzdz(1)=xmin 
       xyzdz(2)=xmax 
       xyzdz(3)=ymin 
       xyzdz(4)=ymax 

       b_logx=.false. 
       b_logy=.false. 
       logx=0 
       logy=0 
       if(b_logx)logx=1 
       logf=0 
       if(b_logy)logf=1 
                                                                        
!      definitions taken from allplo 
       chx='b'                 ! (none,Both,bottom,top)  [B]            
       chbx='n'                ! (none,bottom,top)  [n]                 
       chlr='l'                ! (left,right)  [r]                      
       chy='l'                 ! (none,Both,left,right)  [B]            
       chby='l'                ! (none,left,right)  [r]                 
       chbt='b'                ! (bottom,top)  [t]                      
       chh=0.3                 !                                        
       chw=0.25                ! character cw,ch  [0.40,0.40]           
       syw=0.1                 !                                        
       syh=0.1                 ! symbol sw,sh     [0.40,0.40]           
       frcolor=fgcolor         ! color frame       [black]              
       frcolor='blue'//ch0 
       CTEXT=title 
       CXTEXT=abscissa 
       CYTEXT=ordinata 
                                                                  
       call frame(chx,chbx,chlr,chy,chby,chbt,b_logx,b_logy,            &
                  chh,chw,syw,syh,                                      &
                  CTEXT,CXTEXT,CYTEXT,nformx,nformy,frcolor,bgcolor)      
                                                                        
!      write(6,'(a,4g12.6)')' min-max=',xmin,xmax,ymin,ymax             
!      write(6,'(a,10i5)') ' nchanplot=',(nchanplot(ii),ii=1,8)         
!      write(6,'(2(a,i4))')  ' ny=',ny,'    nyy=',nyy                   
!      write(6,'(a)')  ' j,plotx(j),ploty(j)'                           
!      write(6,'(3(2x,i4,1x,2g12.4))') (j,plotx(j),ploty(j),j=1,ny,16)  
!      write(6,'(a)')  ' j,plotres(j),ploty(j)'                         
!      write(6,'(3(2x,i4,1x,2g10.2))') (j,plotres(j),ploty(j),j=1,ny,16)
                                                                        
      return 
      END                                           

      subroutine drive(mode_drive,nonlinear,nchansp,mvpt,mgpt,mdgpt,mxpt,   &
                       channels_vmax,channel_v0,v_max,geo,vnl,info)
      use glbconst, only: infotext,enwr
      use comthe, only: real_fr 
      implicit none
      integer, intent(in):: mode_drive,nonlinear,nchansp,mxpt,mvpt,mgpt,mdgpt 
      real,    intent(in):: channels_vmax,channel_v0,v_max,geo
      integer, parameter :: nl=18
      real,    dimension(nl), intent(in):: vnl 
      real,    dimension(nl):: cnp       
      integer, intent(out):: info

      real           arg,fold_point,period,period2,    &
                     s,sx,vh,vmax_chan,x,y,chv0per,    &
                     piqp,geof,dfdgeo,h,c1,c4,c5,      &
                     dv0,v1,v2,v3,ph1,ph2,ph3,c1p,c2p,c3p
      real, parameter:: pi=atan(1.)*4.
      integer        ii,j,mode_case,selectnl

   if(nonlinear.lt.0.or.nonlinear.gt.7) then
     info=111
     infotext(1)='<Mossbauer_spectrum>/velocity/nonlinear' 
     infotext(2)=' there are only 0-6 cases for nonlinear ' 
     infotext(3)=' ' 
     return
    end if
    selectnl=nonlinear
    period=channels_vmax*2.0 
    piqp=pi/period
!    piqp=pi/2/channels_vmax

!     calculation  of velocity ,geo, dfdgeo                             
!     nchen mode = +1   triangular wave mode                            
!     nchen mode = +2   sine wave mode 
!     nonlinear= 0-6  (default value is 0)  
!     0: old version with 6 parameter defined in two ways
!         - amplitude and phase shift in channel
!         - amplitude and phase shift in radian
!     1-6: vnl 
!     amplitude and phase shift
    if(enwr(9).eq.'nlco') then
      open(unit=4,file='nlco.dat'         &
                ,status='unknown'         &
                ,access='sequential'      &
                ,form='formatted')   
     write(4,'(2(a,i2))') 'drive_mode=', mode_drive,' case nonlinear=',nonlinear
     write(4,'(a)') 'channel'
     write(4,'(a)') 'dv[mm/s]'
    end if
    h=0.
    do j=1,nl
     h=h+abs(vnl(j))
    end do
    if(h.lt.1.0e-5)selectnl=7
    if(selectnl.eq.2.or.selectnl.eq.5) then
     dv0=0.
     do j=1,nl/2
      call sin2phase(vnl(2*j),vnl(2*j-1),v1,ph1)
      dv0=dv0+v1*cos(ph1)
     end do
    end if
    select case(selectnl) 
     case(0)
      c1p=piqp; c2p=2.0*c1p; c3p=3.0*c1p
      if(abs(vnl(2))+abs(vnl(4))+abs(vnl(6)).lt.2.)then
       call sin2phase(vnl(2),vnl(1),v1,ph1); ph1=ph1/c1p 
       call sin2phase(vnl(4),vnl(3),v2,ph2); ph2=ph2/c2p 
       call sin2phase(vnl(6),vnl(5),v3,ph3); ph3=ph3/c3p
      else
       v1=vnl(1); v2=vnl(3); v3=vnl(5); ph1=vnl(2); ph2=vnl(4); ph3=vnl(6) 
      end if
      dv0= v1*cos(c1p*ph1)+v2*cos(c2p*ph2)+v3*cos(c3p*ph3)

     case(1,2,3)
      do j=1,nl
       cnp(j)=float(2*j-1)*piqp
      end do
     case(4,5,6)
      do j=1,nl
       cnp(j)=float(j)*piqp
      end do
     case(7)
    end select 
    select case(selectnl)
!    piqp=pi/2/channels_vmax
!     y= x-fold_point=channel_v0-(channel_v0+channels_vmax)
!    piqp*y=pi/2/channels_vmax*y= -pi/2
!    case 1,2,3 : -pi/2,-3pi/2, ...
!    case 4,5,6 : -pi/2, -pi, -3pi/2, ...
     case(1,4)
      dv0=0 
      y=-channels_vmax
      do j=1,nl
       dv0=dv0-vnl(j)*cos(cnp(j)*y)
      end do
     case(2,5)
      dv0=0 
      y=-channels_vmax
      do j=1,nl/2
       dv0=dv0-vnl(2*j-1)*cos(cnp(j)*y)-vnl(2*j)*sin(cnp(j)*y)
      end do
     case(3,6)
      dv0=0 
      y=-channels_vmax
      do j=1,nl/2
       dv0=dv0-vnl(2*j-1)*cos(cnp(j)*y)+vnl(2*j)*sin(cnp(j)*y)
      end do
    end select

    fold_point=channel_v0+channels_vmax
    mode_case=abs(mode_drive)
    if(mode_case.gt.3) mode_case=1

    select case(mode_case)
     case(1)
!     triangular wave                                                   
      period2=period*2.0 
      vmax_chan=v_max/channels_vmax 
      chv0per=channel_v0+period 
      do ii=1,nchansp 
       x=float(ii)
       y= x-fold_point
       if(y.gt.0.)goto 30 
!      left side                                                        
       if(y.gt.-period) goto 22 
       x=x+period2 
       goto 32 
   22  c1=channel_v0-x
       s=1. 
       goto 40 
!      right side                                                       
   30  if(y.lt.period) goto 32 
       x=x-period2 
       goto 22 
   32  c1=chv0per-x
       s=-1.              
   40  c4=s*vmax_chan 
       vh=c4*c1 
       h=0.
       select case(selectnl)
        case(0)
         h=dv0-v1*cos(c1p*(y-ph1))-v2*cos(c2p*(y-ph2))-v3*cos(c3p*(y-ph3))

        case(1,4)
         do j=1,nl
          h=h-vnl(j)*cos(cnp(j)*y)
         end do
        case(2,5)
         do j=1,nl/2
          h=h-vnl(2*j-1)*cos(cnp(j)*y)-vnl(2*j)*sin(cnp(j)*y)
         end do
         h=h+dv0
        case(3,6)
         do j=1,nl/2
          h=h-vnl(2*j-1)*cos(cnp(j)*y)-vnl(2*j)*sin(cnp(j)*y)*s
         end do
         h=h+dv0
        case(7)
       end select
       if(enwr(9).eq.'nlco')write(4,'(i4,3x,i5,f15.4)')1000,int(y+period), h

       vh=vh+h
       sx=s*((vh/v_max)**2-1.) 
       c5=1.+geo*sx 
       geof=1./c5**2 
       dfdgeo=-2.*geof/c5*sx 
       real_fr(mvpt+ii) = vh
       real_fr(mgpt+ii) = geof
       real_fr(mdgpt+ii)= dfdgeo
       real_fr(mxpt+ii) = h
      end do 

     case(2)
!     sine wave  
      j=mvpt-3*nchansp                                                       
      do ii=1,nchansp 
       y=float(ii)-fold_point 
       arg=piqp*y                  ! 2*pi/T*t    
       vh=-v_max*cos(arg)
       h=0. 
       select case(selectnl)
        case(0)
         h=dv0-v1*cos(c1p*(y-ph1))-v2*cos(c2p*(y-ph2))-v3*cos(c3p*(y-ph3))

        case(1,4)
         do j=1,nl
          h=h-vnl(j)*cos(cnp(j)*y)
         end do
        case(2,5)
         do j=1,nl/2
          h=h-vnl(2*j-1)*cos(cnp(j)*y)-vnl(2*j)*sin(cnp(j)*y)
         end do
         h=h+dv0
        case(3,6)
         do j=1,nl/2
          h=h-vnl(2*j-1)*cos(cnp(j)*y)-vnl(2*j)*sin(cnp(j)*y)
         end do
         h=h+dv0
        case(7)
       end select
       if(enwr(9).eq.'nlco')write(4,'(i4,3x,i5,f15.4)')1000,int(y+period), h

       vh=vh+h
       sx=sin(arg)
       c5=1.+geo*sx                ! geo=s_max/F 
       geof=1./c5**2 
       dfdgeo=-2.*geof/c5*sx 
       real_fr(mvpt+ii) = vh
       real_fr(mgpt+ii) = geof
       real_fr(mdgpt+ii)= dfdgeo
       real_fr(mxpt+ii) = h
      end do 
    
     case(3)
!     mode_drive=3
      if(abs(real_fr(mvpt+1)-real_fr(mvpt+nchansp)).gt.2*abs(v_max))then
      info=nchansp 
       infotext(1)='<Mossbauer_spectrum>/velocity/scale' 
       infotext(2)='**error** x-data do not fit to v_max ' 
       infotext(3)=' ' 
       return
      end if
      do ii=1,nchansp 
       vh=real_fr(mvpt+ii) 
       y=float(ii)-fold_point
       sx=-((vh/v_max)**2-1.)*sign(1.0,y) 
       c5=1.+geo*sx 
       geof=1./c5**2 
       dfdgeo=-2.*geof/c5*sx 
       real_fr(mgpt+ii) = geof
       real_fr(mdgpt+ii)= dfdgeo
      end do 
    end select
    if(enwr(9).eq.'nlco')close(unit=4)
   return 
   END                                           
   
    subroutine sin2phase(vsn,vcs,v,p) 
    real, intent(in)::vsn,vcs
    real, intent(out):: v,p  
    real(kind=8), parameter:: pi=ATAN(1.d0)*4.d0
    real(kind=8) ::vsin,vcos,vh,ph
    vcos=vcs; vsin=vsn
     if(vcos.eq.0.) then
      ph=pi/2.0
      if(vsin.lt.0)ph=-ph
     else
      ph=ATAN(vsin/vcos); 
     end if
     vh=sqrt(vcos**2+vsin**2)
     if(vcos.lt.0.and.vsin.lt.0)then
      vh=-vh
     else
      if(vcos.lt.0)ph=ph+pi; if(vsin.lt.0)ph=ph+2.d0*pi
     end if 
     v=vh; p=ph
    return
    END
                                                                        
     subroutine geometry(icase,N_om_samp,Dsource,Dabsorber,d_source,d_absorber, &
                         Daperture,sc2absorber,sc2aperture,geo,geof,enpr,&
                         cosa,a_R,jt)
     implicit none 
                                                                       
     integer,             intent(in) :: N_om_samp
     real,                intent(in) :: Dsource,Dabsorber,d_source,d_absorber, &
                                        Daperture,sc2absorber,sc2aperture,geo,geof
     character(len=4) , intent(inout):: enpr
     integer,           intent(inout):: icase
     integer,             intent(out):: jt
     real,dimension(1320),intent(out):: cosa,a_R

     integer, save:: N_S,N_B
     real,    save:: r_B,r_S,sumi0,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF 

!    d_absorber is the deviation from the axis: center of the source to
!    center aperture of the detector.                                  
!    d_source is the deviation from the axis: center of the absorber to
!    center aperture of the detector.                                  

!    extern struct geom{} in mosgeowin.c
     real        BoverFd,AoverFd,SoverFd,HoverFd,DAoverFd,DSoverFd,         &
                 sc2apertured,gdetectord,geod                               
     common/geom/BoverFd,AoverFd,SoverFd,HoverFd,DAoverFd,DSoverFd,  &
                 sc2apertured,gdetectord,geod                          

     integer       i,j,nB,nR,nS,jR 
     real          w_R,RR,RoverF,cc,h,hh,h0,h1,xi,xi2,yi,v2,kx,ky,k2,  &
                   tau,tau2,maxtau,mintau,cyp_max,cym_min,gdetector             
     real, parameter :: r4=3.0, r11=4.4641, r20=6.2915, r33=8.2111 
                                                                       
!    number 1,5,6,21,22 are of half weight                             
!    1-4 (r=3), 1-11 (2*sq3+1), 1-20 (2*sq7+1) 1-33 (2*sq13+1)         
     real, dimension(66)  :: &
        xy=(/0.0, 0.000,1.0, 1.732,1.0,-1.732,2.0, 0.000,              &
             0.0, 3.464,0.0,-3.464,2.0, 3.464,2.0,-3.464,              &
             3.0, 1.732,3.0,-1.732,4.0, 0.000,                         &
             1.0, 5.196,1.0,-5.196,3.0, 5.196,3.0,-5.196,              &
             4.0, 3.464,4.0,-3.464,5.0, 1.732,5.0,-1.732,              &
             6.0, 0.000,                                               &
             0.0, 6.928,0.0,-6.928,2.0, 6.928,2.0,-6.929,              &
             4.0, 6.928,4.0,-6.928,5.0, 5.196,5.0,-5.196,              &
             6.0, 3.464,6.0,-3.464,7.0, 1.732,7.0,-1.732,              &
             8.0, 0.000/)                                               
     real, dimension(33)  :: &
      wt=(/0.5,1.,1.,1.,0.5,0.5,1. ,1. ,1.,1.,1.,1.,1.,1.,             &
             1., 1.,1.,1.,1. ,1. ,0.5,0.5,1.,1.,1.,1.,1.,1.,           &
             1., 1.,1.,1.,1./)                                          
                                                                       
!     om_samp             :    constant                 [0]             
!     Dsource             :    constant                 [0.5]           
!     Dabsorber           :    constant from experiment [1.6]           
!     Daperture           :    constant from experiment [2.5]           
!     F=sc2aperture       :    constant from experiment [10.0]          
!     H=sc2absorber       :    parameter                [5.0]           
!     d_absorber          :    parameter                [0.0]           
!     d_source            :    parameter                [0.0]           
!     geo                 :    parameter                [0.00000]       
                                                                        
                                                                        
!     10 different cases of the geometry                                
!     uvwx   , 0 dynamically decided                                    
!     u=1,2 point/extended source                                       
!     v=1,2 intersection/full image or aperture                         
!     w=1,2 image of the absorber/ aperture                             
!     x=1,2 alignment/misalignment 
      gdetector=6. 
      if(icase.gt.0) goto 10 
      N_B=N_om_samp+1 
                                                                        
      SoverF=Dsource/sc2aperture 
      AoverF=Dabsorber/sc2aperture 
      BoverF=Daperture/sc2aperture 
                                                                        
      DAoverF=d_absorber/sc2aperture 
      DSoverF=d_source/sc2aperture 
      HoverF=sc2absorber/sc2aperture 
!        write(6,'(a,8f10.3)')' Ds,Da,Dap,d_s,d_a,sab,sap=',            
!     &  Dsource,Dabsorber,Daperture,d_source,d_absorber,               
!     &  sc2absorber,sc2aperture                                        
                                                                        
      BoverFd=BoverF 
      AoverFd=AoverF 
      SoverFd=SoverF 
      HoverFd=HoverF 
      DAoverFd=DAoverF 
      DSoverFd=DSoverF 
      sc2apertured=sc2aperture 
      gdetectord=gdetector 
      geod=abs(geo) 
!        write(6,'(a,i3,2x,6f10.3)')' N_B,S,A,B,DA,H/F=',               
!     &  N_B,SoverF,AoverF,BoverF,DAoverF,DSoverF,HoverF                
                                                                        
      tau=1.0/(1.0-sqrt(geof)*(1-HoverF)) 
      tau2=tau**2 
      maxtau=(1-geo)/(HoverF-geo) 
      mintau=(1+geo)/(HoverF+geo) 
      if(SoverF.le.0.0001) then 
!      case of point source                                             
       if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then 
!       alignment                                                       
!       case=1001                                                       
        icase=1 
                                                                        
        i=0 
        RR=AoverF/2.0 
        if(RR*tau.lt.BoverF/2.) then 
         w_R=RR/N_B 
        sumi0=1. 
        jr=1. 
        do nR=2,N_B 
         RoverF=(nR-0.5)*w_R 
         jr=jr+2 
         h=1.0/(1.0+(RoverF/HoverF)**2) 
         sumi0=sumi0+ h*sqrt(h)*jr 
        end do 
!           write(6,'(a,10f10.5)')                                      
!     &  'a  sumi0,tau,AoverF,BoverF,w_R=',sumi0,tau,AoverF,BoverF,w_R  
             ! RR.gt.BoverF/2.                                          
        else 
         w_R=BoverF/2./N_B 
        sumi0=1. 
        jr=1. 
        do nR=2,N_B 
         RoverF=(nR-0.5)*w_R 
         jr=jr+2 
         h=1.0/(1.0+RoverF**2) 
         sumi0=sumi0+ h*sqrt(h)*jr 
        end do 
!           write(6,'(a,10f10.5)')                                      
!     &  'b  sumi0,tau,AoverF,BoverF,w_R=',sumi0,tau,AoverF,BoverF,w_R  
        end if 
        if(enpr.eq.'plot') then 
         print '(a)', 'point source/alignment icase=1' 
         if(RR*maxtau.le.BoverF/2) then 
          print '(a)', 'image of absorber is smaller than/equal aperture'
         else if(RR*mintau.gt.BoverF/2) then 
          print '(a)', 'image of absorber is larger than aperture' 
         else if(RR*mintau.lt.BoverF/2.and.RR*maxtau.gt.BoverF/2) then 
          print '(a,/a)', '**aperture** absorber image/aperture <> 1',&
           ' depends on the position of the source'                      
         end if 
         call geompointsc 
         enpr='nnnn'
        end if 
       else  ! abs(DAoverF)+abs(DSoverF)> 0    
!       misalignment                                                    
                                                                        
        h=DAoverF-DSoverF+AoverF/2. 
        if(h.gt.0)then 
         cyp_max=DSoverF+h*maxtau 
        else 
         cyp_max=DSoverF+h*mintau 
        end if 
        h=DAoverF-DSoverF-AoverF/2. 
        if(h.gt.0)then 
         cym_min=DSoverF+h*mintau 
        else 
         cym_min=DSoverF+h*maxtau 
        end if 
                                                                        
        sumi0=0.0 
        if(cyp_max.le.BoverF/2..and.cym_min.ge.-BoverF/2.)then 
!        Intersection is the full image of the absorber                 
!        case=1212                                                      
         if(enpr.eq.'plot') then 
          print '(a,2(/,a))',' point source/misalignment icase=2',  &
          ' image of the absorber inside aperture',                     &
          ' integration over image by circles'                          
          call geompointsc 
          enpr='nnnn'
         end if 
                                                                        
         icase=2 
         RR=AoverF/2.0 
         if(N_B.le.4)then 
          N_B=4 
          r_B=RR/r4 
         else if(N_B.le.11)then 
          N_B=11 
          r_B=RR/r11 
         else if(N_B.le.20)then 
          N_B=20 
          r_B=RR/r20 
         else if(N_B.gt.20)then 
          N_B=33 
          r_B=RR/r33 
         end if 
                                                                        
         i=-1 
         do nB=1,N_B 
          i=i+2 
          xi=xy(i)*r_B 
          yi=DAoverF-DSoverF+xy(i+1)*r_B 
          h=1.0/(1.0+(xi**2+yi**2)*tau2) 
          sumi0=sumi0+h*sqrt(h)*wt(nB) 
         end do 
!        write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                   
        else if(cyp_max.gt.BoverF/2..and.cym_min.lt.-BoverF/2.)then 
!        Intersection is the full aperture                              
!        case=1222                                                      
         if(enpr.eq.'plot') then 
          print '(a,2(/,a))',' point source/misalignment icase=3',  &
        ' image of the absorber larger than aperture',                  &
        ' integration over aperture by circles'                         
          call geompointsc 
          enpr='nnnn'
         end if 
                                                                        
         icase=3 
!         write(6,'(a,5f12.3)')'mintau,maxtau,cyp_max,cym_min,BoverF/2='
!     &                         mintau,maxtau,cyp_max,cym_min,BoverF/2  
         RR=BoverF/2.0 
         if(N_B.le.4)then 
          N_B=4 
          r_B=RR/r4 
         else if(N_B.le.11)then 
          N_B=11 
          r_B=RR/r11 
         else if(N_B.le.20)then 
          N_B=20 
          r_B=RR/r20 
         else if(N_B.gt.20)then 
          N_B=33 
          r_B=RR/r33 
         end if 
         i=-1 
         do nB=1,N_B 
          i=i+2 
          xi=xy(i)*r_B 
          yi=-DSoverF+xy(i+1)*r_B 
          h=1.0/(1.0+xi**2+yi**2) 
          sumi0=sumi0+h*sqrt(h)*wt(nB) 
         end do 
!        write(6,'(a,10f10.3)')'sumi0=',sumi0                           
        else 
!        Intersection; image of the absorber filled with cirles         
!        case=1112                                                      
         if(enpr.eq.'plot') then 
          print '(a,3(/,a))',' point source/misalignment icase=4',  &
        ' intersection of absorber image and aperture depends on the',  &
        ' position of the source; integration over aperture by circles',&
        ' with smooth edge'                                             
          BoverFd=-BoverFd 
          call geompointsc 
         end if 
                                                                        
         RR=AoverF/2.0 
         icase=4 
         RR=AoverF/2. 
         if(N_B.le.4)then 
          N_B=20 
          r_B=RR/r20 
         else if(N_B.gt.4)then 
          N_B=33 
          r_B=RR/r33 
         end if 
                                                                        
         i=-1 
         do nB=1,N_B 
          i=i+2 
          xi2=(xy(i)*r_B*tau)**2 
          yi=(DAoverF-DSoverF+xy(i+1)*r_B)*tau 
          h=1.0/(1.0+(xi2+yi**2)) 
          hh=h*sqrt(h)*wt(nB) 
          cc=sqrt(xi2+(DSoverF+yi)**2)/BoverF*8.-3. 
          if(cc.gt.0.) then 
!         image out of aperture cirle (decreasing weight)               
           hh=hh*exp(-(cc*gdetector)**2) 
          end if 
          sumi0=sumi0+hh 
!         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                  
         end do 
        end if 
       end if 
                  ! Dsource > 0                                         
      else 
!      ################## extended source ############################  
!     v=1,2 intersection/full image or aperture                         
!     w=1,2 image of the absorber/ aperture                             
!     x=1,2 alignment/misalignment                                      
                                                                        
       sumi0=0.0 
       tau=1.0/(1.0-sqrt(geof)*(1-HoverF)) 
       tau2=tau**2 
                                                                        
       if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then 
!       alignment                                                       
!       case=2001                                                       
        icase=5 
                                                                        
        h=AoverF-SoverF 
        if((h.gt.0.0.and.SoverF+h*mintau.gt.BoverF).or.                 &
           (h.lt.0.0.and.SoverF+h*maxtau.gt.BoverF)) then               
!        image covers aperture for all source points                    
!        integration over aperture (rings), source circles              
!        2221                                                           
         icase=5 
         if(enpr.eq.'plot') then 
          print '(a,2(/,a))',' extended source/alignment icase=5',  &
          ' image covers aperture for all source points',               &
          ' integration over aperture by rings and source by circles'   
          call geomextendsc 
          enpr='nnnn' 
         end if 
                                                                        
         RR=SoverF/2. 
         if(N_B.le.4)then 
          N_S=4 
          r_S=RR/r4 
         else if(N_B.le.11)then 
          N_S=11 
          r_S=RR/r11 
         else if(N_B.gt.11)then 
          N_S=20 
          r_S=RR/r20 
!         else if(N_B.gt.20)then                                        
!         N_S=33                                                        
!         r_S=RR/r33                                                    
!         never more than 20 circles for the source=> less than 20*20 va
         end if 
                                                                        
         w_R=BoverF/2.0/N_B 
         jR=-1 
         do nR=1,N_B 
          RoverF=(nR-0.5)*w_R 
          jR=jR+2 
          i=-1 
          do nS=1,N_S 
           i=i+2 
           v2=(xy(i)*r_S)**2+(RoverF-xy(i+1)*r_S)**2 
           h=1./(1.+v2) 
           sumi0=sumi0+h*sqrt(h)*wt(nS)*jR 
!           write(6,'(2i4,a,6f12.3)')nS,nR,' sqrt(h)=',                 
!     &        sqrt(h),wt(nS),RoverF*sc2aperture                        
          end do 
         end do 
!         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                  
        else 
         h=AoverF+SoverF 
         if(-SoverF+(AoverF+SoverF)*maxtau.lt.BoverF) then 
         if(enpr.eq.'plot') then 
          print '(a,2(/,a))',' extended source/alignment icase=6',  &
          ' image inside aperture for all source points',               &
          ' integration over image, source by rings/image by circles'   
          call geomextendsc 
          enpr='nnnn' 
         end if 
!         2211                                                          
          icase=6 
                                                                        
          RR=AoverF/2. 
          if(N_B.le.4)then 
           N_B=4 
           r_B=RR/r4 
          else if(N_B.le.11)then 
           N_B=11 
           r_B=RR/r11 
          else if(N_B.le.20)then 
           N_B=20 
           r_B=RR/r20 
          else if(N_B.gt.20)then 
           N_B=33 
           r_B=RR/r33 
          end if 
                                                                        
          tau2=tau**2 
          w_R=SoverF/2.0/N_B 
          jR=-1 
          do nS=1,N_B 
           RoverF=(nS-0.5)*w_R 
           jR=jR+2 
           i=-1 
           do nB=1,N_B 
            i=i+2 
            kx=xy(i)*r_B 
            ky=-RoverF+xy(i+1)*r_B 
            h=1.0/(1.0+(kx**2+ky**2)*tau2) 
            sumi0=sumi0+h*sqrt(h)*wt(nB)*jR 
           end do 
          end do 
              ! general case of an alignment                            
         else 
          if(enpr.eq.'plot') then 
           print '(a,2(/,a))',' extended source/alignment icase=7', &
          ' source source/aperture <> 1 dependent on source position',  &
          ' integration over aperture (by circles) with smooth edge'    
          BoverFd=-BoverFd 
          call geomextendsc 
          enpr='nnnn' 
         end if 
!         2111                                                          
          icase=7 
                                                                        
          w_R=SoverF/2.0/N_B 
          jR=-1 
          do nS=1,N_B 
           RoverF=(nS-0.5)*w_R 
           jR=jR+2 
           i=-1 
           do nB=1,N_B 
            i=i+2 
            kx=xy(i)*r_B 
            ky=-RoverF+xy(i+1)*r_B 
            h=1.0/(1.0+(kx**2+ky**2)*tau2) 
            hh=h*sqrt(h)*wt(nB)*jR 
            cc=sqrt((tau*xy(i)*r_B)**2+                                 &
                    (RoverF*(1.-tau)+tau*xy(i+1)*r_B)**2)/BoverF*8.-3.  
            if(cc.gt.0.0) then 
             hh=hh*exp(-(cc*gdetector)**2) 
            end if 
            sumi0=sumi0+hh 
           end do 
          end do 
!         write(6,'(a,10f10.3)')'sumi0,tau=',sumi0,tau                  
         end if 
        end if 
                                                                        
             ! abs(DAoverF)+abs(DSoverF)> 0                             
       else 
        if(enpr.eq.'plot') then 
         print '(a,2(/,a))',                                        &
          ' extended source/misalignment icase=8',                      &
          ' integration by cirles (source and aperture)',               &
          ' aperture with smooth edge'                                  
         BoverFd=-BoverFd 
         call geomextendsc 
         enpr='nnnn' 
        end if 
!       2122                                                            
        icase=8 
        RR=SoverF/2. 
        if(N_B.le.4)then 
         N_S=4 
         r_S=RR/r4 
        else if(N_B.le.11)then 
         N_S=11 
         r_S=RR/r11 
        else if(N_B.gt.11)then 
         N_S=20 
         r_S=RR/r20 
!        else if(N_B.gt.20)then                                         
!        N_S=33                                                         
!        r_S=RR/r33                                                     
!        never more than 20 circles for the source=> less than 20*33 val
        end if 
                                                                        
        RR=AoverF/2. 
        if(N_B.le.4)then 
         N_B=20 
         r_B=RR/r20 
        else if(N_B.gt.4)then 
         N_B=33 
         r_B=RR/r33 
        end if 
        jt=0 
        j=-1 
        do nS=1,N_S 
         j=j+2 
         xi=xy(j)*r_S 
         yi=xy(j+1)*r_S+DSoverF 
 2200    i=-1 
         do nB=1,N_B 
          i=i+2 
          jt=jt+1 
          k2=(xy(i)*r_B-xi)**2+(xy(i+1)*r_B+DAoverF-yi)**2 
          h=1./(1.+k2*tau2) 
          hh=h*sqrt(h)*wt(nS) 
          h1=sqrt((xi*(1.-tau)+tau*xy(i)*r_B)**2                        &
               +(yi*(1.-tau)+tau*(DAoverF+xy(i+1)*r_B))**2)             
          cc=h1/BoverF*8.-3. 
!             /BoverF*8.-3.                                             
!               -BoverF/2.                                              
          if(cc.ge.0.0) then 
           hh=hh*exp(-(cc*gdetector)**2) 
!           write(6,'(3i4,a,4f12.3)')jt,nS,nB,' sqrt(h), exp=',  &       
!            sqrt(h),exp(-(cc*gdetector)**2),h1*sc2aperture*sign(1.,xi) 
!          else                                                         
!           write(6,'(3i4,a,4f12.3)')jt,nS,nB,' sqrt(h), exp=',  &       
!            sqrt(h),1.0,h1*sc2aperture*sign(1.,xi)                     
          end if 
          sumi0=sumi0+hh 
         end do 
         if(xi.gt.0)then 
          xi=-xi 
          goto 2200 
         end if 
        end do 
       end if 
      end if 
                                                                        
                                                                        
   10 continue 
      jt=0 
      tau=1.0/(1.0-sqrt(geof)*(1-HoverF)) 
      tau2=tau**2 
                                                                        
  select case(icase)                                                                       
    case(1)
!     point source case=1, alignment                                    
!     dynamical decission according to tau(v)                           
!     normalization to effective efficiency at s=0 for all v.           
!     at that point is geof=1                                  
                                                                        
      jt=1 
      cosa(jt)=1.0 
      a_R(jt)=geof 
      jr=1. 
      RR=AoverF/2.0 
      if(RR*tau.lt.BoverF/2.) then 
       w_R=RR/N_B 
      do nR=2,N_B 
       RoverF=(nR-0.5)*w_R 
       jt=jt+1 
       jr=jr+2 
       h=1.0/(1.0+geof*RoverF**2*tau2) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof*jr*h*cosa(jt) 
!         if(ichansp.eq.123)then                                        
!           write(6,'(a,10f10.5)')                                      
!     &  '1001  tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)=',               
!     &            tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)               
!         end if                                                        
      end do 
           ! RR.gt.BoverF/2.                                            
      else 
       w_R=BoverF/2./N_B 
      do nR=2,N_B 
       RoverF=(nR-0.5)*w_R 
       jt=jt+1 
       jr=jr+2 
       h=1.0/(1.0+geof*RoverF**2) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof*jr*h*cosa(jt) 
!         if(ichansp.eq.123)then                                        
!           write(6,'(a,10f10.5)')                                      
!     &  '1001  tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)=',               
!     &            tau,AoverF,BoverF,w_R,a_R(jt),cosa(jt)               
!         end if                                                        
      end do 
      end if 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
    case(2)                                                                        
!     parameter (r4=3.0, r11=4.4641, r20=6.2915, r33=8.2111)            
!     number 1,5,6,21,22 are of single weight                           
!     1-4 (r=3), 1-11 (2*sq3+1), 1-20 (2*sq7+1) 1-33 (2*sq13+1)         
!     point source case=1, misalignment                                 
                                                                        
!     else if(cyp_max.le.BoverF/2..and.cym_max.ge.-BoverF/2.)then       
!     Intersection is the full image of the absorber                    
!     number 1,5,6,21,22 are of single weight                           
      i=-1 
      do nB=1,N_B 
       i=i+2 
       jt=jt+1 
       xi=xy(i)*r_B 
       yi=DAoverF-DSoverF+xy(i+1)*r_B 
       h=1.0/(1.0+geof*(xi**2+yi**2)*tau**2) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof*h*cosa(jt)*wt(nB) 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
    case(3)                                                                        
!     Intersection is the full image of the aperture                    
!     number 1,5,6,21,22 are of single weight                           
      i=-1 
      do nB=1,N_B 
       i=i+2 
       xi=xy(i)*r_B 
       yi=-DSoverF+xy(i+1)*r_B 
       jt=jt+1 
       h0=xi**2+yi**2 
       h=1.0/(1.0+geof*h0) 
       cosa(jt)=sqrt(h) 
       a_R(jt)=geof*h*cosa(jt)*wt(nB) 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
   case(4)  
!     else if(cym_min.lt.-BoverF/2.) then                               
!     Intersection; image of the absorber filled with cirles            
!     number 1,5,6,21,22 are of single weight                           
      hh=BoverF/2 
      i=-1 
      do nB=1,N_B 
       i=i+2 
       jt=jt+1 
       xi2=(xy(i)*r_B*tau)**2 
       yi=(DAoverF-DSoverF+xy(i+1)*r_B)*tau 
       h=1.0/(1.0+geof*(xi2+yi**2)) 
       a_R(jt)=geof*h*sqrt(h)*wt(nB) 
       cc=sqrt(xi2+(DSoverF+yi)**2)/BoverF*8.-3. 
       if(cc.gt.0.) then 
!       image out of aperture cirle (decreasing weight)                 
        a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2) 
       end if 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do 
   case(5) 
!     ##################### extended source ##########################  
!     if(abs(DAoverF)+abs(DSoverF).lt.0.0001) then                      
!     alignment                                                         
!     image covers aperture for all source points                       
!     integration over aperture (rings), source circles                 
      hh=0. 
      w_R=BoverF/2.0/N_B 
      jR=-1 
      do nR=1,N_B 
       RoverF=(nR-0.5)*w_R 
       jR=jR+2 
       i=-1 
       do nS=1,N_S 
        jt=jt+1 
        i=i+2 
        v2=(xy(i)*r_S)**2+(RoverF-xy(i+1)*r_S)**2 
        h=1./(1.+geof*v2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof*h*cosa(jt)*wt(nS)*jR 
!        if(ichansp.eq.1)then                                           
!          write(6,'(2i4,a,6f12.3)')nS,nR,' sqrt(h)=',                  
!     &        sqrt(h),wt(nS),float(jR)                                 
!        end if                                                         
       end do 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do

    case(6) 
!     integration over image, source ring/image circles                 
!     image inside aperture for all source points                       
      w_R=SoverF/2.0/N_B 
      jR=-1 
      do nS=1,N_B 
       RoverF=(nS-0.5)*w_R 
       jR=jR+2 
       i=-1 
       do nB=1,N_B 
        jt=jt+1 
        i=i+2 
        kx=xy(i)*r_B 
        ky=-RoverF+xy(i+1)*r_B 
        h=1.0/(1.0+geof*(kx**2+ky**2)*tau2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof*h*cosa(jt)*wt(nB)*jR 
       end do 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do
   case(7)
!     source rings and image circles;                                   
!     aperture simulated by smooth edge                                 
      w_R=SoverF/2.0/N_B 
      jR=-1 
      do nS=1,N_B 
       RoverF=(nS-0.5)*w_R 
       jR=jR+2 
       i=-1 
       do nB=1,N_B 
        jt=jt+1 
        i=i+2 
        kx=xy(i)*r_B 
        ky=-RoverF+xy(i+1)*r_B 
        h=1.0/(1.0+geof*(kx**2+ky**2)*tau2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof*h*cosa(jt)*wt(nB)*jR 
        cc=sqrt((tau*xy(i)*r_B)**2+                                     &
                (RoverF*(1.-tau)+tau*xy(i+1)*r_B)**2)/BoverF*8.-3.      
        if(cc.gt.0.0) then 
         a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2) 
        end if 
       end do 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do
   case(8) 
!     Intersection; general case; image filled with circles             
!     finite aperture simulated by a smooth edge                        
      j=-1 
      do nS=1,N_S 
       j=j+2 
       xi=xy(j)*r_S 
       yi=xy(j+1)*r_S+DSoverF 
 2201  i=-1 
       do nB=1,N_B 
        jt=jt+1 
        i=i+2 
        k2=(xy(i)*r_B-xi)**2+(xy(i+1)*r_B+DAoverF-yi)**2 
        h=1./(1.+geof*k2*tau2) 
        cosa(jt)=sqrt(h) 
        a_R(jt)=geof*h*cosa(jt)*wt(nS) 
        h1=sqrt((xi*(1.-tau)+tau*xy(i)*r_B)**2+                         &
                (yi*(1.-tau)+tau*(DAoverF+xy(i+1)*r_B))**2)             
          cc=h1/BoverF*8.-3. 
        if(cc.ge.0.0) then 
         a_R(jt)=a_R(jt)*exp(-(cc*gdetector)**2) 
!         if((ichansp.eq.256.or.ichansp.eq.768).and.a_R(jt).gt.0.01)    
!          write(6,'(3i4,a,4f10.3)')jt,nS,nB,' sqrt(h), exp=',sqrt(h), 
!           exp(-(cc*gdetector)**2),h1*sc2aperture*sign(1.,xi),a_R(jt) 
!        else                                                           
!          if((ichansp.eq.256.or.ichansp.eq.768).and.a_R(jt).gt.0.01)   
!            write(6,'(3i4,a,4f10.3)')jt,nS,nB,' sqrt(h), exp=',       
!           sqrt(h),1.0,h1*sc2aperture*sign(1.,xi),a_R(jt)             
        end if 
       end do 
       if(xi.gt.0)then 
        xi=-xi 
        goto 2201 
       end if 
      end do 
      do i=1,jt 
        a_R(i)=a_R(i)/sumi0 
      end do
   end select 
   return 
   END                                           
                                                                        
                                                                        
                                                                        
      subroutine moss_selsubspect(text) 
      use glbconst, only: maxfr1,maxfr2,maxscr,maxss,maxthss,maxsub,nrd,nwr
      use complt, only: n_int,n_subset
      implicit none  

      character(len=40),intent(in):: text(3)
      character(len=4)  :: c_array 
      integer, parameter:: illc=3*(maxfr1+1+maxfr2+maxthss) 
      integer           :: mstruct1,istruct1,istruct2,iaddr
      character(len=64) :: frthname
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    c_array(illc),frthname(2),iaddr(8) 

      character(len=40) :: htext,text1,text2
      character(len=132):: ch132,cp132,chcom
      character(len=1)  :: ch1
      logical   bs_and_a 
      real,   dimension(32)     :: out
      integer,dimension(maxss+3):: npanum
      integer   i,ik,ipos,iout,is,is_a,is_and_a,is_e,iset,j,j1,j2,      &
                j_int,jabsorber,jsource,ji,jj,jz,kk,lay,mlay,n_ssub,nn, &
                ia,ii

      mlay=istruct1(mstruct1) 
!     mlay : number of layers                                           
!     subspectra for the plot, calculating subspectrum(1024,12)         
       jz=1 
       do while(text(2)(jz:jz).eq.' ') 
        jz=jz+1 
       end do 
       j2=1 
       do while(text(2)(jz:jz).ne.' ') 
        text2(j2:j2)=text(2)(jz:jz) 
        if(jz.eq.40) goto 801 
        jz=jz+1 
        j2=j2+1 
       end do 
  801  continue 
       jz=1 
       do while(text(1)(jz:jz).eq.' ') 
        jz=jz+1 
       end do 
       j1=1 
       do while(text(1)(jz:jz).ne.' ') 
        text1(j1:j1)=text(1)(jz:jz) 
        if(jz.eq.40) goto 802 
        jz=jz+1 
        j1=j1+1 
       end do 
  802   continue 
                                                                        
      is=0 
      do lay=1,mlay 
       is_a=istruct2(lay-1)+1 
       is_e=istruct2(lay) 
       htext=text(2) 
       if(lay.eq.1) htext=text(1) 
       if(lay.eq.mlay.and.mstruct1.eq.3) htext=text(3) 
       if(is_e.ge.is_a) then 
                                                                        
        write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',           &
            htext(1:jz),' sites from ',is_a,' to ',is_e                 
        is=is+is_e-is_a+1 
       end if 
      end do 
!      if((index(text(1),'source').gt.0.and.istruct2(mlay).lt.3)        
      if(is.lt.3) then 
       write(nwr,'(a)') '**  there are no sub-spectra ** ' 
       return 
      end if 
      is_and_a=0 
      bs_and_a=.true. 
!      if(index(text(1),'source').gt.0.and.istruct2(1).eq.1) then       
      if(istruct2(1).eq.1) then 
!      no source sub-spectrum                                           
       bs_and_a=.false. 
       is_and_a=1 
      end if 
      if(istruct2(mlay)-istruct2(1).eq.1) then 
!      no absorber  sub-spectrum                                        
       bs_and_a=.false. 
       is_and_a=2 
      end if 
                                                                        
                                                                        
  809  if(bs_and_a) then 
        write(nwr,'(/,6a)') ' sub-spectrum_j of ',                      &
       text1(:j1),'(ji) and ',text2(:j2),'(ki).',                      &
         ' Number j (h-ide), sites: j1...jn k1...kn'                   
                                                                        
       else if(is_and_a.eq.1)then 
        write(nwr,'(/,3a)') ' sub-spectrum_j of the ',                  &
       text2(:j2),'  Number j (h-hide),  site: k1...kn'                
                                                                        
       else if(is_and_a.eq.2)then 
        write(nwr,'(/,3a)') ' sub-spectrum_j of the ',                  &
       text1(:j1),'  Number j (h-ide), site: j1...jn '                 
       end if 
                                                                        
       i=1 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        i=i+1 
        if(i-1.eq.maxsub) goto 8091 
       end do 
 8091  ik=i-1 
                                                                        
       i=0 
  805  i=i+1 
        j_int=abs(n_int(i,0)) 
        kk=0 
        do jj=1,j_int 
         if(n_int(i,jj).gt.is_e) kk=kk+1 
        end do 
        if(kk.gt.0)then 
         do kk=i,ik 
          j_int=abs(n_int(kk+1,0)) 
          if(j_int.gt.0) then 
           do jj=0,j_int 
            n_int(kk,jj)=n_int(kk+1,jj) 
           end do 
          else 
           do jj=0,maxss 
            n_int(ik,jj)=0 
           end do 
          end if 
         end do 
         ik=ik-1 
         i=i-1 
        end if 
        if(i.lt.ik)goto 805 
                                                                        
  810  i=1 
       n_subset=0 
       do while(i.le.maxsub.and.abs(n_int(i,0)).gt.0) 
        ch1=' ' 
        if(n_int(i,0).lt.0) ch1='h' 
        j_int=abs(n_int(i,0)) 
        kk=0 
        do jj=1,j_int 
         if(n_int(i,jj).gt.is_e) kk=kk+1 
        end do 
        if(kk.gt.0)then 
         n_int(i,0)= 0 
         j_int=0 
         i=i-1 
        end if 
        if(is_and_a.eq.0) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int)               
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int)               
        end if 
        if(is_and_a.eq.1) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=2,j_int)               
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=2,j_int)               
        end if 
        if(is_and_a.eq.2) then 
         if(i.le.9) write(nwr,'(a,i1,a1,1x,32i3)')                      &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int-1)             
         if(i.gt.9) write(nwr,'(a,i2,a1,32i3)')                         &
         ' sub-spectrum_',i,ch1,(n_int(i,jj),jj=1,j_int-1)             
        end if 
        if(ch1.eq.' ')  n_subset=i 
        i=i+1 
        if(i-1.eq.maxsub) goto 811 
       end do 
  811  n_ssub=i-1 
                                                                        
  820  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/input' 
        call help(chcom) 
        goto 809 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 810 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
        i=1                                                               
        call panum(ch132,maxss,npanum,i)
        if(i.ne.1) goto 820 
!        write(6,'(a)')' npanum(1-npanum(2))'                           
!        write(6,'(20i3)')(npanum(j),j=1,npanum(2)+2)                   
                                                                        
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a,i3)') ' maximal number of sub-spectra ',maxsub 
          goto 810 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
         ' at least the number of the sub-spectrum (or *)'             
          goto 820 
        end if 
        if(iout.eq.1) then 
!        hide a sub-spectrum                                            
         if(ch132(1:1).eq.'h') then 
          if(n_int(iset,0).lt.0) then 
           n_int(iset,0)= abs(n_int(iset,0)) 
           do j=maxsub,2,-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub) then 
            do ji=0,maxss 
             n_int(1,ji)=n_int(iset+1,ji) 
             n_int(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_int(iset,0)=-abs(n_int(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(iset,ji) 
             n_int(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
!        remove a sub-spectrum                                          
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_int(maxsub,ji)=0 
          end do 
!          write(6,'(8i3)')n_int                                        
         end if 
        end if 
!       write(6,'(a,10i4)') ' 1 out=',(int(out(j)),j=1,iout)            
                                                                        
        if(iout.eq.2.and.bs_and_a) then 
         write(nwr,'(a)')                                               &
         '**** at least one source and absorber sub-spectrum'          
          goto 820 
        end if 
                                                                        
        if(iout.ge.2) then 
         nn=out(2) 
         if(nn.gt.istruct2(1).and.bs_and_a) then 
          write(nwr,'(a,i2)')                                           &
         '**** at least one source sub-spectrum  <=',istruct2(1)       
          goto 820 
         end if 
!        write(6,'(a,10i4)') ' 2 out=',(int(out(j)),j=1,iout)           
         n_int(iset,0)=0 
         jsource=0 
         jabsorber=0 
         iout=npanum(2)+1 
!         do j=2,iout                                                   
!          nn=out(j)                                                    
          do j=2,iout 
          nn=npanum(1+j) 
          if(nn.gt.is_e) then 
           write(nwr,'(a,i5,a)') ' ***',nn,' is not a sub-spectrum' 
          else 
           if(nn.le.istruct2(1)) jsource=jsource+1 
           if(nn.gt.istruct2(1)) jabsorber=jabsorber+1 
           if(is_and_a.eq.0) then 
            n_int(iset,0)=j-1 
            n_int(iset,j-1)=nn 
           end if 
           if(is_and_a.eq.1) then 
            n_int(iset,0)=j 
            n_int(iset,1)=1 
            n_int(iset,j)=nn 
            jsource=1 
           end if 
           if(is_and_a.eq.2) then 
            n_int(iset,0)=j 
            n_int(iset,j-1)=nn 
            n_int(iset,j)=istruct2(mlay) 
            jabsorber=1 
           end if 
          end if 
         end do 
         if(jsource.eq.0.and.bs_and_a) then 
           write(nwr,'(a)')                                             &
          '****  at least one sub-spectrum of the source '             
           goto 820 
          end if 
          if(jabsorber.eq.0.and.bs_and_a) then 
           write(nwr,'(a)')                                             &
          '****  at least one sub-spectrum of the absorber'            
           goto 820 
          end if 
         end if 
!        write(6,'(a,10i4)')'n_int(1,0)=',(n_int(1,ji),ji=0,5)          
         jj=n_ssub 
         do i=1,maxsub-1 
          if(n_int(i,1).lt.0.and.n_int(i+1,1).gt.0) then 
           jj=jj+1 
           if(jj.le.maxsub) then 
            do ji=0,maxss 
             n_int(jj,ji)=n_int(i,ji) 
            end do 
           else 
            do ji=0,maxss 
             n_int(i,ji)=0 
            end do 
           end if 
          end if 
         end do 
         do i=1,maxsub 
          if(n_int(i,1).eq.0) then 
           do j=i,maxsub-1 
            do ji=0,maxss 
             n_int(j,ji)=n_int(j+1,ji) 
            end do 
           end do 
          end if 
         end do 
         goto 810 
       end if  ! * out            
                                                                        
      return 
      END                                           

     subroutine moss_subspect(cmch,mi,info) 
     use glbconst, only: maxn,maxthss,maxsub,icstrf,ivstrf,MDBPLFT
     use complt, only: n_subset,n_int
     use comthe, only: thfk
     implicit none 
     character(len=4),intent(in) :: cmch 
     integer,         intent(in) :: mi
     integer,         intent(out):: info


     real    dum,channels,avsp,f_factor,base,dumcsp,dumcvs
     common/acstrf/ dum(5),channels,dumcsp(icstrf-6)                          
     common/avstrf/ avsp,f_factor,base,dumcvs(ivstrf-3) 
    
     real             :: datx,errx,sym,subspectrum,parray,thfkd
     integer,parameter:: max4=4*maxn, jdumpl=8*(max4+2)+4*(max4/2)+max4, &
                         idumpl= maxn*144+jdumpl,                        &
                         kdumpl=3*max4+max4*maxsub,                      &
                         ldumpl=MDBPLFT*2-144*maxn-jdumpl-kdumpl
    common/plot/parray(idumpl),datx(max4),errx(max4),sym(max4),          &
                subspectrum(max4,maxsub),thfkd(ldumpl)

     real        p0 
     real,dimension(maxthss):: plold 
     integer nchansp,i,ip,l,ll,j,k1                                 
                                                                        
      nchansp=channels 
      do i=1,max4 
       thfkd(i)=thfk(i) 
      end do 
                                                                        
       call calpl('test') 
                                                                        
       do  i=1,mi 
        plold(i)=0.0 
        call replace_wi(-i,plold(i),info)  ! - take out and write on plo
       end do 
!       write(6,'(i3,a,9f10.3)')mi,' subsp-plold(1..)=',(plold(i),i=1,mi
       nchansp=channels 
                                                                        
       do  l=1,n_subset 
        p0=0.0 
        do j=1,mi 
         call replace_wi(j,p0,info)  ! + write 0 to wi values 
        end do 
!       write(6,'(a,i4,a,30i3)')' l_subsp=',l,                          
!     &         ' n_int(l,ll)=',(n_int(l,ll),ll=0,n_int(l,0))           
        do ll=1,n_int(l,0) 
         ip=n_int(l,ll) 
         call replace_wi(ip,plold(ip),info)  ! + write plold(ip) to wi v
        end do 
                                                                        
        k1=3 
        call sel_the2exp(cmch,k1,info) 
        do  i=1,nchansp 
         subspectrum(i,l)=thfk(i) 
        end do 
!        write(6,'(a,i4)') '  sub-spectrum i=',l                        
!        write(6,'(4e15.6)') (thfk(i),i=1,nchansp,64)                   
       end do 
                                                                        
       do  i=1,mi 
        call replace_wi(i,plold(i),info)  ! + write plold(i) to wi value
       end do 
!       call moss_the2exp(k1,info)                                      
                                                                        
      do i=1,max4 
       thfk(i)=thfkd(i) 
      end do 
      return 
      END                                           
                                                                        
!------------------------------------------------------------------     
                                                                        
      subroutine moss_selsubtract(text,isub) 
      use glbconst, only: maxfr1,maxfr2,maxscr,maxss,maxthss,maxsub,nrd,nwr
      use complt, only:   n_sub
      use comthe, only:   array_fr
      implicit none
                                                                        
      character(len=40),intent(in) :: text(3)
      integer,          intent(out):: isub 

      integer,parameter :: maxsouab=5
      character(len=4)  :: c_array 
      integer, parameter:: illc=3*(maxfr1+1+maxfr2+maxthss)      
      integer     mstruct1,istruct1,istruct2,iaddr,idum,ipSI
      character(len=64):: frthname
      common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                    c_array(illc),frthname(2),                          &
                    idum(4),ipSI,iaddr(3)
                                                                        
      real,dimension(32):: out 
      character(len=40) :: htext,texta
      character(len=132):: ch132,cp132,chcom
      character(len=1)  :: ch1
                                                                        
      integer,parameter :: jSI=maxsub*(maxss+1)
      integer,dimension(maxss+3):: npanum
      integer,dimension(2*jSI)  :: i_int
      integer,dimension(maxsub,0:maxss):: n_source,n_absorber 
      equivalence (i_int(1),n_source), (i_int(jSI+1),n_absorber) 

      integer   i,ia,ii,is_a,is_e,iset,j,jab,ji,jj,jsou,jsource,        &
                lay,laye,mlay,n_ssub,nn,iout,ipos,lch


      do i=1,jSI 
       i_int(i)=real(array_fr(ipSI+i)) 
       i_int(i+jSI)=aimag(array_fr(ipSI+i)) 
      end do

      do i=1,maxsub 
       n_source(i,0)=0 
       n_absorber(i,0)=0 
      end do 

!     mlay : number of layers                                           
      mlay=istruct1(mstruct1) 
                                                                        
      laye=mlay 
      if(mstruct1.eq.3) laye=mlay-1 
      n_source(1,0)=0 
      if(istruct2(1).eq.1) goto 875 
       is_a=1 
       is_e=istruct2(1) 
       htext=text(1) 
       write(nwr,'(a,2(a,i2))')                                         &
        htext(:24),' sites from ',is_a,' to ',is_e                     
        cp132=htext 
        call nextchar(cp132,0,ipos,ch132,lch) 
        write(nwr,'(/,2a)')ch132(1:lch),                                &
            '_subsp_j      j1   j2 ...  [j=1]'                         
  860  i=1 
       do while(abs(n_source(i,0)).gt.0) 
        ch1=' ' 
        if(n_source(i,0).lt.0) ch1='h' 
        write(nwr,'(a,i1,a1,1x,32i3)') ' source_subsp_',                &
            i,ch1,(n_source(i,jj),jj=1,abs(n_source(i,0)))             
        i=i+1 
        if(i.gt.maxsouab) goto 861 
       end do 
  861  n_ssub=i-1 
                                                                        
  870  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/subtract/source' 
         call help(chcom) 
         goto 860 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 860 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
        i=1
        call panum(ch132,maxss,npanum,i) 
        if(i.ne.1) goto 870  
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a)') ' maximal number of sub-spectra reached' 
          goto 860 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
         ' at least the number of the sub-spectrum (or *)'             
          goto 870 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_source(iset,0).lt.0) then 
           n_source(iset,0)= abs(n_source(iset,0)) 
           do j=maxsouab,2,-1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub)then 
            do ji=0,maxss 
             n_source(1,ji)=n_source(iset+1,ji) 
             n_source(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_source(iset,0)=-abs(n_source(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(iset,ji) 
             n_source(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_source(j,ji)=n_source(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_source(maxsub,ji)=0 
          end do 
         end if 
        end if 
                                                                        
        if(iout.ge.2) then 
        n_source(iset,0)=0 
        jsource=0 
        iout=npanum(2)+1 
                                                                        
        do j=2,iout 
!        nn=out(j)                                                      
         nn=npanum(1+j) 
         if(nn.gt.istruct2(1)) then 
         write(nwr,'(a,i2,a)')                                          &
         '**** ',nn,' is not a source sub-spectrum  '                  
         else 
          jsource=jsource+1 
          n_source(iset,0)=j-1 
          n_source(iset,j-1)=nn 
         end if 
        end do 
         if(jsource.eq.0) then 
         write(nwr,'(a)')                                               &
         '****  no source sub-spectrum  '                              
         goto 870 
         end if 
        end if 
                                                                        
        jj=n_ssub 
        do i=1,maxsouab-1 
         if(n_source(i,1).lt.0.and.n_source(i+1,1).gt.0) then 
          jj=jj+1 
          if(jj.le.maxsouab) then 
           do ji=0,maxss 
            n_source(jj,ji)=n_source(i,ji) 
           end do 
          else 
           do ji=0,maxss 
            n_source(i,ji)=0 
           end do 
          end if 
         end if 
        end do 
        do i=1,maxsouab 
         if(n_source(i,1).eq.0) then 
          do j=i,maxsouab-1 
           do ji=0,maxss 
            n_source(j,ji)=n_source(j+1,ji) 
           end do 
          end do 
         end if 
        end do 
        goto 860 
               ! * out                                                  
       end if 
                                                                        
                                                                        
  875 do lay=2,mlay 
       is_a=istruct2(lay-1)+1 
       is_e=istruct2(lay) 
       htext=text(2) 
       if(lay.eq.mlay.and.mstruct1.eq.3) htext=text(3) 
       if(is_a.le.is_e)                                                 &
       write(nwr,'(a,i2,a2,2a,i2,a,i2)') ' layer(',lay,'):',           &
                  htext(1:24),' sites from ',is_a,' to ',is_e          
      end do 
                                                                        
  879 cp132=htext 
      call nextchar(cp132,0,ipos,ch132,lch) 
      texta=ch132 
      write(nwr,'(/,2a)')ch132(1:lch),                                  &
            '_subsp_j      j1   j2 ...  [j=1]'                         
  880 i=1 
      do while(abs(n_absorber(i,0)).gt.0) 
       ch1=' ' 
       if(n_absorber(i,0).lt.0) ch1='h' 
       write(nwr,'(2a,i1,a1,1x,32i3)') texta(:lch),'_subsp_',           &
          i,ch1,(n_absorber(i,jj),jj=1,abs(n_absorber(i,0)))           
       i=i+1 
       if(i.gt.maxsouab) goto 881 
      end do 
  881 n_ssub=i-1 
                                                                        
  890  read(nrd,'(a)') ch132 
       call lc_character(ch132) 
       if(ch132(1:2).eq.'he') then 
        i=index(frthname(1),' ') 
        chcom='<'//frthname(1)(1:i-1)//'>/sub-spectra/subtract/absorber' 
         call help(chcom) 
         goto 879 
       end if 
       if (ch132(1:1).ne.'*'.and.ch132(1:1).ne.'q') then 
        if (ch132(1:1).eq.'#') goto 880 
        call nextchar(ch132,0,ipos,cp132,ii) 
        call nextchar(cp132,ii,ipos,ch132,ia) 
        i=1
        call panum(ch132,maxss,npanum,i) 
        if(i.ne.1) goto 890           
        call trlch(80,cp132,iout,out) 
        iset=out(1) 
        if(iset.gt.maxsub) then 
          write(nwr,'(a)') ' maximal number of sub-spectra reached' 
          goto 880 
        end if 
        if(iout.lt.1) then 
          write(nwr,'(a)')                                              &
         ' at least the number of the sub-spectrum (or *)'             
          goto 890 
        end if 
        if(iout.eq.1) then 
         if(ch132(1:1).eq.'h') then 
          if(n_absorber(iset,0).lt.0) then 
           n_absorber(iset,0)= abs(n_absorber(iset,0)) 
           do j=maxsouab,2,-1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(j-1,ji) 
            end do 
           end do 
           if(iset.lt.maxsub)then 
            do ji=0,maxss 
             n_absorber(1,ji)=n_absorber(iset+1,ji) 
             n_absorber(iset+1,ji)=0 
            end do 
           end if 
          else 
           n_absorber(iset,0)=-abs(n_absorber(iset,0)) 
           if(iset.lt.n_ssub) then 
            j=n_ssub+1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(iset,ji) 
             n_absorber(iset,ji)=0 
            end do 
           end if 
          end if 
         end if 
         if(ch132(1:2).eq.'rm') then 
          if(iset.lt.maxsub) then 
           do j=iset,maxsub-1 
            do ji=0,maxss 
             n_absorber(j,ji)=n_absorber(j+1,ji) 
            end do 
           end do 
          end if 
          do ji=0,maxss 
           n_absorber(maxsub,ji)=0 
          end do 
         end if 
        end if 
                                                                        
        if(iout.ge.2) then 
        n_absorber(iset,0)=0 
        iout=npanum(2)+1 
        do j=2,iout 
!        nn=out(j)                                                      
         nn=npanum(1+j) 
        if(nn.le.istruct2(1).or.nn.gt.istruct2(laye)) then 
         write(nwr,'(a,i2,a)')                                          &
         '**** ',nn,' is not an absorber sub-spectrum  '               
         else 
          n_absorber(iset,0)=j-1 
          n_absorber(iset,j-1)=nn 
         end if 
        end do 
        end if 
                                                                        
        jj=n_ssub 
        do i=1,maxsouab-1 
         if(n_absorber(i,1).lt.0.and.n_absorber(i+1,1).gt.0)then             
          jj=jj+1 
          if(jj.le.maxsouab) then 
           do ji=0,maxss 
            n_absorber(jj,ji)=n_absorber(i,ji) 
           end do 
          else 
           do ji=0,maxss 
            n_absorber(i,ji)=0 
           end do 
          end if 
         end if 
        end do 
        do i=1,maxsouab 
         if(n_absorber(i,1).eq.0) then 
          do j=i,maxsouab-1 
           do ji=0,maxss 
            n_absorber(j,ji)=n_absorber(j+1,ji) 
           end do 
          end do 
         end if 
        end do 
        goto 880 
               ! * out                                                  
       end if 
                                                                        
!      source sub-spectra (and all absorber sub-spectra)                
       isub=1 
       if(n_source(1,0).gt.0) then 
        isub=2 
        n_sub(1,0)=n_source(1,0)+istruct2(laye)-istruct2(1) 
        do j=1,n_source(1,0) 
         n_sub(1,j)=n_source(1,j) 
        end do 
        do j=1,n_sub(1,0)-n_source(1,0) 
         n_sub(1,j+n_source(1,0))=istruct2(1)+j 
        end do 
                ! source sub-spectra                                    
       end if 
                                                                        
!      absorber sub-spectra (and remaining source sub-spectra)          
                                                                        
       jsou=0 
       do j=1,istruct2(1) 
        jj=0 
        do i=1,abs(n_source(1,0)) 
         if(abs(n_source(1,i)).eq.j) jj=1 
        end do 
        if(jj.eq.0) then 
         jsou=jsou+1 
         n_sub(0,jsou)=j 
        end if 
       end do 
                                                                        
        do j=1,jsou 
         n_sub(isub,j)=n_sub(0,j) 
        end do 
                                                                        
        jj=jsou 
        do j=1,n_absorber(1,0) 
          jj=jj+1 
          n_sub(isub,jj)=n_absorber(1,j) 
        end do 
        n_sub(isub,0)=jj 
                                                                        
!    reaining sub-spectrum stored in n_sub(0,j)                         
                                                                        
       jab=0 
       do j=istruct2(1)+1,istruct2(laye) 
        jj=0 
        do i=1,n_sub(isub,0) 
         if(n_sub(isub,i).eq.j) jj=1 
        end do 
        if(jj.eq.0) then 
         jab=jab+1 
         n_sub(0,jsou+jab)=j 
        end if 
       end do 
       n_sub(0,0)=jsou+jab 
                                                                        
      do i=1,jSI 
       array_fr(ipSI+i)=cmplx(i_int(i),i_int(i+jSI)) 
      end do 
                                                                        
!       do i=1,isub                                                     
!       write(nwr,'(a,i1,2x,32i3)')                                     
!     &    ' sub-spectrum_',i,(n_sub(i,jj),jj=1,abs(n_sub(i,0)))        
!       end do                                                          
       write(nwr,'(a,1x,2x,32i3)')                                      &
         ' residual spectrum sites',(n_sub(0,jj),jj=1,abs(n_sub(0,0))) 
                                                                        
       print '(a)',' ' 
       print '(a)','                         **** CALCULATING ****' 
       return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine moss_subtract(cmch,mi,isub,info) 
      use glbconst, only: maxn,maxthss,maxsub,icstrf,ivstrf,MDBPLFT
      use comdat, only: ichanks,mxpt,mfpt
      use complt, only: n_sub
      use comthe, only: real_fr,thfk
      implicit none 
      character(len=4), intent(in) :: cmch 
      integer,          intent(in) :: mi,isub
      integer,          intent(out):: info  
      integer, parameter:: nl=18
      real         dum,channels,dum1,drive_mode,channels_vmax,c_nonlinear,dumcs
     common/acstrf/dum(5),channels,dum1(3),drive_mode,channels_vmax, &
                   c_nonlinear,dumcs(icstrf-12)            
     real          avsp,f_factor,base,bg_fraction,v_max,               &
                   channel_v0,geo,vnl,dumvs
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,channel_v0,geo,vnl(nl),    &
                   dumvs(ivstrf-7-nl)         

     integer       ibe,mvpt,mgpt,mdgpt,ien
     common/strLOC/ibe(3),mvpt,mgpt,mdgpt,ien(26)

                                                                        
     real             :: datx,errx,sym,subspectrum,parray,thfkd  
     integer,parameter:: max4=4*maxn, jdumpl=8*(max4+2)+4*(max4/2)+max4, &
                         idumpl= maxn*144+jdumpl,                        &
                         kdumpl=3*max4+max4*maxsub,                      &
                         ldumpl=MDBPLFT*2-144*maxn-jdumpl-kdumpl
    common/plot/parray(idumpl),datx(max4),errx(max4),sym(max4),          &
                subspectrum(max4,maxsub),thfkd(ldumpl)

!      real velocity,geof,dfdgeo,p0 
!      common/adrive/  velocity(maxn),geof(maxn),dfdgeo(maxn) 
      real p0 
      real, dimension(maxthss) :: plold 
      integer nchansp,i,j,jj,k,k1                                     
                                                                        
      nchansp=channels 

      call drive(int(drive_mode),int(c_nonlinear),nchansp,mvpt,mgpt,mdgpt,       &     
                 mxpt,channels_vmax,channel_v0,v_max,geo,vnl,info)
      if(info.gt.0)return

      do i=1,max4 
       thfkd(i)=thfk(i) 
      end do 
                                                                        
!     write(6,'(a,i4)') ' ********** mi=',mi                            
                                                                        
       call calpl('test') 
       do  i=1,mi 
        plold(i)=0.0 
        call replace_wi(-i,plold(i),info)  ! - take out and write on plold
       end do 
!      subtract y - yy                                                  
                                                                        
!      absorber complete , source and detector window subtracted        
                                                                        
       p0=0.0 
       do j=1,isub 
        do i=1,mi 
         call replace_wi(i,p0,info)  ! + write 0 to wi values  
        end do 
                                                                        
        do i=1,n_sub(j,0) 
         jj=abs(n_sub(j,i)) 
         call replace_wi(jj,plold(jj),info)  ! + write plold(jj) to wi v
        end do  
                                                                        
        k1=3 
        call sel_the2exp(cmch,k1,info) 
                                                                        
!      write(6,'(a)') ' ------1----back in subtract----------------'    
                                                                        
        do k=2,ichanks(0),2 
         do i=ichanks(k-1),ichanks(k) 
          real_fr(mfpt+i)=real_fr(mfpt+i)-(thfk(i)-base*real_fr(mgpt+i)) 
         end do 
        end do 
       end do ! isub
                                                                        
!      calculation of the theory of the stripped spectrum               
       p0=0.0 
       do i=1,mi 
        call replace_wi(i,p0,info)   ! + write 0.0 to wi values   
       end do 
                                                                        
       do i=1,n_sub(0,0) 
        jj=n_sub(0,i) 
        call replace_wi(jj,plold(jj),info)   ! + write plold(jj) to wi va
       end do 
                                                                        
       k1=3 
         ! values are not reset by calpl, written on theory-array       
       call sel_the2exp(cmch,k1,info) 
                                                                        
!      write(6,'(a)') ' ------2----back in subtract----------------'    
!      restore parameters                                               
       call calpl('test') 
                                                                        
      do i=1,max4 
       thfk(i)=thfkd(i) 
      end do 
      return 
      END                                           
                                                                        
!      subroutine forstruct                                             
!      implicit none                                                    
!      use glbconst                                             
!      integer      istruct,idum                                        
!      parameter   (istruct=2+4*maxfr1+4+4*maxfr2+3*maxthss+32+8)  
!      common/struct/idum(istruct)                                      
!      return                                                           
!      end                                                              
                                                                        
     subroutine mosstrans_mcarlo(nu_channel) 
     use glbconst, only: iseed,ivstrf,nwr,nrd
     use comthe, only: thfk
     implicit none 
                                                                       
     real          avsp,f_factor,base,bg_fraction,dumvsp                   
     common/avstrf/avsp,f_factor,base,bg_fraction,dumvsp(ivstrf-4) 
                                                                       
     integer i,nu_channel,ledit,npl
     real    win_fraction,countrate,deadtime,                          &
             sweepfrequency,ameasuretime,printtime,dwelltime,          &
             start,finish,bg_fract,fres  
     character(len=132):: chcrd,chcom
     character(len=1)  :: ch1

     real,dimension(7):: value
     character(len=40),dimension(7):: name          
        bg_fract=bg_fraction+(1.-f_factor)*(1.-bg_fraction) 
        fres=f_factor*(1.-bg_fraction) 
        do i=1,nu_channel 
         thfk(i)=1.+(thfk(i)/base-1.)/fres 
        end do 
                                                                        
        npl=80
!       25:32 information about the helpfile (th110105)                 
!             if 25:32 is empty chcom is taken by subroutine conread    
!             as defined below                                          
!       33:37 format (effi specific) of the number                      
!                  1234567890123456789012345678901234567                
        name(1)='win_fraction                    f04.2)' 
        name(2)='countrate(/sec)                 e08.1)' 
        name(3)='deadtime (ms)                   e06.1)' 
        name(4)='sweepfrequency(Hz)              f05.1)' 
        name(5)='measure_time (sec)              i03)' 
        name(6)='printtime (sec)                 i03)' 
        name(7)='iseed                           i09)' 
                                                                        
        win_fraction=0.8     ! fraction of conuts in the window  
        countrate=1.e5       ! in the window     
        deadtime=1.e-5 
        sweepfrequency=10. 
        ameasuretime=30 
        printtime=10 
        iseed=-222 
                                                                        
        chcrd='1-7' 
        chcom='<Mossbauer_spectrum>/trans/simulation/montecarlo' 
                                                                        
        value(1)=win_fraction   ! fraction of conuts in the window 
        value(2)=countrate      ! in the window
        value(3)=deadtime 
        value(4)=sweepfrequency 
        value(5)=ameasuretime 
        value(6)=printtime 
        value(7)=iseed 
                                                                        
        ledit=0 
        call conread(chcrd,value,name,7,chcom,ledit) 
                                                                        
        win_fraction=  value(1) 
        countrate=     value(2) 
        deadtime=      value(3) 
        sweepfrequency=value(4) 
        ameasuretime=  value(5) 
        printtime=     value(6) 
        iseed=         value(7) 

        chcrd='start of Monte Carlo ' 
        ch1='y' 
        chcom='effi/mcarlo_true' 
        call yesno(chcrd,ch1,chcom,npl,nrd,nwr) 
        if(ch1.eq.'n') return
                                                                        
        dwelltime=1./sweepfrequency/nu_channel 
        call cpu_time(start) 
        call mosstranscounts(base,nu_channel,win_fraction,bg_fract,     &
           countrate,deadtime,dwelltime,ameasuretime,printtime,iseed)  
                                                                        
        call cpu_time(finish) 
        print '(" runtime = ",f15.3," seconds.")',finish-start 
                                                                        
        return 
      END                                           
                                                                        
                                                                        
      subroutine channel_content(mode_drive,vm,v0,vp,ym,y0,yp,dv,cc)
      implicit none
      integer, intent(in):: mode_drive
      real, intent(in):: vm,v0,vp,ym,y0,yp,dv
      real, intent(out):: cc
      
      real  fm,f0,fp,dm,d0,dp,det1,det2,alpha,beta,gamma,vm2,v02,vp2,ypm,yp0m,h
      integer        i

!     known : i=int(v0/dv)  -> ym=yth(i-1), y0=yth(i), yp=yth(i+1) 
      h=vm/dv; i=int(h); dm= h-float(i)
      h=v0/dv; i=int(h); d0= h-float(i)
      h=vp/dv; i=int(h); dp= h-float(i)

!     theory values at vm,vo,vp
      ypm=yp-ym; yp0m=yp-2.0*y0+ym
      fm=y0+dm*(ypm+dm*yp0m)/2.0
      f0=y0+d0*(ypm+d0*yp0m)/2.0
      fp=y0+dp*(ypm+dp*yp0m)/2.0
      
     if(mode_drive.eq.1) then
!     delta_v constant
       cc=f0+(fp-fm)/4.+(fp-2*f0+fm)/6.
!     write(11,'(i6,g15.5)') k,(fp-fm)/4. !+(fp-2*f0+fm)/6.
     else
!     v0-vm # vp-v0;
!     f(v) = alpha* v**2 +beta*v +gamma
!     the 3 equations for fm,f0,fp determine alpha,beta,gamma 
      if(abs(vp-vm).lt.1.e-5)then
       cc=f0+(fp-fm)/4.+(fp-2*f0+fm)/6.
       return
      end if
      det1=(v0-vm)*(vp-vm)
      det2=(vp-v0)*(vp-vm)
      vm2=vm**2; v02=v0**2; vp2=vp**2
      alpha=(fp-f0)/det2-(f0-fm)/det1
      beta= (vp+v0)*(f0-fm)/det1-(v0+vm)*(fp-f0)/det2

      gamma=f0-alpha*v02-beta*v0
!     integration from v0 till vp
      cc=gamma+alpha*(vp2+vp*v0+v02)/3. + beta*(vp+v0)/2.
     end if

     return
     end
