!     author : h. spiering                                              
!              institut f. anorg. u. anal. chemie                       
!              johannes gutenberg-universitaet                          
!              d-55099 mainz                                            
!              last version october 2006                                
     subroutine fr_mossbauer(cmch,iss,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxsub,maxss,maxthss,maxs,&
                         icstrf,ivstrf,nwr,ncl
     use comdat, only: b_data,b_theory,mxpt,mfpt,mdfpt,               &
                       name_data,name_theory
                       ! mfpt,mdfpt are transferred to the routine fit
     use complt, only: n_subset
     use comthe, only: array_fr,theoryname,thfrcase,ifrcase,ifrsto,mGa,ibmisfit
     use comstr, only: nu_device                                               
     implicit none 

     character(len=4), intent(inout) :: cmch
     integer,          intent(in) :: iss
     integer,          intent(out):: info 

     integer       mstruct1,istruct1,istruct2,                        &
                   l1_get,l2_get,l3_get,l1_put,l2_put,l3_put,         &
                   ipTHS,ipTH,ipTHyy,ipSI,iposLG,ipt,iaddr       
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   ipt,iposLG,ipTHS,ipTH,ipTHyy,ipSI,iaddr(2)

     real          srw8 
     integer       jpolsource,jpolabsorber,km,mvpt,mgpt,mdgpt,ifrth,  &
                   iflag_basis,idum1,nLG,nAS,nSC,idum2,ak8,sk8,ien
     common/strLOC/jpolsource,jpolabsorber,km,mvpt,mgpt,mdgpt,ifrth(6),&
                   iflag_basis,idum1,nLG,nAS,nSC,idum2,ak8,sk8,srw8,ien(11)
                                                                       
     real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,       &
                   th_dum,drive_mode,channels_vmax,dum,flag_basis,     &
                   c_nonlinear,om_samp,Dsource,Dabsorber,              &
                   sc2absorber,sc2aperture,dumcs                       
     common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,     &
                   vm_SC,convol,th_dum,drive_mode,channels_vmax,       &
                   c_nonlinear,om_samp,Dsource,Dabsorber,              &
                   sc2absorber,sc2aperture,dumcs(icstrf-17)            
                                                                       
     real    avsp,f_factor,base,bg_fraction,v_max,                     &
             channel_v0,v_g1,v_u1,v_g2,v_u2,v_g3,v_u3,geo,             &
             Daperture,d_absorber,d_source,dumvs                       
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,               &
             channel_v0,v_g1,v_u1,v_g2,v_u2,v_g3,v_u3,geo,             &
             Daperture,d_absorber,d_source,dumvs(ivstrf-16)            

      integer    kshandle,hold,whandle,idum 
      common/win/kshandle,hold,whandle(maxs),idum(18*maxs+404) 
                                                                           
     character(len=132):: ch132,cp132
     character(len=1)  :: ch1
     character(len=40),dimension(3):: text 
                                                                       
     integer mode_drive,lstruct1,lstruct2,lstruct3,                    &
             nchanDA,nchanLG,nchanTHS,nchanTH,nchansp,                 &
             mi,k1,k2,isub,ak2,sk2,kzl,kzla,kzls,ib,ib2          
!***********************************************************************

!     transmission versionS(ifrcase)=transmission_vS(6)  version uvw
      if(cmch.eq.'thna') then 
       theoryname='Mossbauer radioactive source        v=210' 
       thfrcase(1)='Mossbauer transmission_vA(1)       v=210' 
       thfrcase(2)='Mossbauer transmission_vB(3)       v=210' 
       thfrcase(4)='Mossbauer reemission_vA(2)         v=200'        
       thfrcase(5)='Mossbauer reemission_vB(4)         v=200' 
       thfrcase(3)='Mossbauer transmission_vC(5)       v=200' 
       thfrcase(6)='Mossbauer transmission_vD(3)       v=200' 
       thfrcase(7)='Mossbauer transmission_vS(6)       v=100' 
       return 
      end if 
!     thfrcase(8)

!     version v=200:
!     the pointers have got a new sequence.
!     the second one is the end of the experimental data
!     ipt,"iposLG",ipTHS,ipTH,ipTHyy,ipSI,iaddr(3)
!     iposLG (pointer for array of the complex Lorentz-Gauss curve) 
!     The routine tpg_lorgau.f90 stores parameters at iposLG-5,...,iposLG-1
!     in order to follow the alteration and necessary recalculation
!     of the Loentz-Gauss curve (case flag_SAMP=1)
!     If any constant is changed, all logical values are put to .false.,
!     such that effi recalculates all routines. 
!***********************************************************************
      ien(11)=0
      nchansp=channels 
      if(cmch.eq.'arr0') then
!     storage space
!      Data     info  nLG+1     th_A      th_exp    str_sub
!     |.........|.|..........|.........|.........|..........|
!     ipt nchanDa iposLG     ipTH     ipTHyy     ipSI     

       nchanDA=3*nchansp  ! complex = 6*nchansp of real
                          ! for mfpt,mdfpt,mxpt,mvpt,mgpt,mdgpt
       iposLG=nchanDA+6   ! info=5 Lorentz-Gauss parameter, positon LG

       ipt=0              ! absolute address incremented in common/struct/
       ifrsto=0 

       ibmisfit=1
       iflag_basis=flag_basis 

       km=nchansp/32
       km=8*km
       if(km.lt.128)km=128
       if(km.gt.512)km=512
       ib=convol 
       if (ib.gt.2*km) ib=2*km 

       ib2=ib*2 
       if(abs(vm_SC).gt.0.0) then 
        kzl=int(km*vm_SC/abs(v_max))    ! km =: v_max
       else 
        kzl=0
       end if 
!       write(6,'(a,i5,2f10.2)') 'frame01 kzl=',kzl,vm_SC,v_max        
       if(kzl.gt.0) then 
        kzls=2*km 
        kzla=kzl*2 
        if(kzla.gt.2*km) kzla=2*km 
       else 
        kzla=2*km 
        kzls=abs(kzl)*2 
        if(kzls.gt.2*km) kzls=2*km 
       end if 
                                                                       
       sk2=kzls 
       ak2=kzla 
       sk8=sk2*4 
       ak8=ak2*4 
                                                                       
       if(kzla.gt.kzls) then
        nSC=sk2+ib2 
        nAS=ak2+nSC            
       else 
        nAS=ak2+ib2 
        nSC=sk2+nAS
       end if 
                                                                       
       nLG=4*(nAS+nSC) 
!       write(6,'(a,4i5)')'fr_mossbauer kzla,kzls,nSC,nAS=',kzla,kzls,nSC,nAS
        nchanLG=5+nLG+1         ! 5 for info; Lorentz-Gauss ; +1 dummy
        nchanTH=km+1            ! channels of the normalized spectrum 

       if(ifrcase.eq.6) then                                                               
        nchanTHS=4*(2*nSC+1)+3  ! source refractionindex for selfabsorption
                                ! 2 for icase, nz, thickness of 1mue, 
                                ! electronic absorption of 1 mue, 1 dummy
        ifrsto=nchanDA+nchanLG+nchanTHS+nchanTH+nchansp/2+maxsub*(1+maxss)
        ipTHS=nchanDA+nchanLG 
        ipTH=ipTHS+nchanTHS
        jpolsource=1 
       else  
        nchanTHS=0
        ipTHS=0
        ifrsto=nchanDA+nchanLG+nchanTH+nchansp/2+maxsub*(1+maxss)
        ipTH=nchanDA+nchanLG 
        jpolsource=0 
!       lstuct1case is assigned in the main routine mossbauer during execution
       end if
        ipTHyy=ipTH+nchanTH 
        ipSI=ipTHyy+nchansp/2 
        jpolabsorber=0 
       return 
      else if(cmch.eq.'arri') then 
       ifrsto=0 
       call l_structure(iss,lstruct1,lstruct2,lstruct3) 
       if(nu_device(lstruct1).eq.1.and.lstruct3.gt.0) then 
!       write(6,'(a,i1,a2,a)')'c3_prp(',lstruct3,')=',c3_prp(lstruct3)
        if(c3_prp(lstruct3).eq.'plrs') then
         jpolsource=1
        end if         
       end if 
       if(nu_device(lstruct1).eq.2) then 
        if(lstruct2.gt.0) then 
         if(lstruct3.eq.0) then 
                                                                       
          if(istruct2(lstruct2)-istruct2(lstruct2-1).gt.1) then 
!          storage for a layer with more than 1 site (storage for      
!          a polarized layer )                                         
           ifrsto=ifrsto+4*(nAS+1)
          end if 
         else 
          if(c3_prp(lstruct3).eq.'plrs') jpolabsorber=1 
         end if 
        else 
!        storage for each device                                       
         ifrsto=4*(nAS+1)+(km+1) 
!        if there are more than one absorber (incoherent) the unweighted
!        spectrum of each absorber is stored                           
!         if(ifrcase.eq.5)ifrsto=ifrsto+(km+1)                         
        end if 
       end if 
       if(nu_device(lstruct1).eq.3.and.lstruct3.gt.0) then 
!       detector is always assumed to be unpolarized                   
        ifrsto=nSC+1
       end if 
       return 
      else if(cmch.eq.'arre') then 
      return       
     end if         ! arr0,i,e
!    **************************************************************** 
      if(.not.b_theory) then 
!       absolute address of nstorSI is known here                       
        do k1=1,maxsub*(1+maxss) 
         array_fr(ipSI+k1)=(0.,0.) 
        end do 
      end if
      if(Dabsorber.gt.888..or.Dabsorber.lt.0. )om_samp=0.  
      ! there are theories which do not use the routines for geometry 
      ! effects, so that om_samp is undefined/8888.8 respectively.
      ! The subroutine moss_the2exp() calculates this effect if om_samp >=1
                                
      if(km.gt.0)srw8=abs(v_max)/float(km)/8
      ! not very nice -> km,ipt are not yet defined when calling dstr
      mode_drive=drive_mode 
      if(mode_drive.lt.1.or.mode_drive.gt.3)mode_drive=1 
      mi=istruct2(istruct1(mstruct1)) 
                                                                        
!     storag on real_fr(2*(iarraysp+nstorFR)+m) (array_f)              
!     corresponds to the i= drive_mode (label 100) 
      mfpt=ipt*2                 ! y data from real_fr (factor 2)  
      mdfpt=mfpt +nchansp        ! errors of y data (calculated by sqrt
      mvpt =mdfpt+nchansp        ! x data (velocity) drive_mode=3
      mgpt =mvpt +nchansp        ! velocity(i) calculated by drive
      mdgpt =mgpt +nchansp        ! geof(i) calculated by drive
      mxpt=mdgpt +nchansp        ! dfdgeo(i) calculated by drive
!     write(6,'(a,10i10)')'mfpt..',ipt,mfpt,mdfpt,mxpt,mvpt,mgpt,mdgpt
!     write(6,*) ipTH,nchanTH,ipTHyy,ipSI,iposLG,iaddr
!     write(6,*)  'channel_v0=',channel_v0,cmch
!   ******************************************************************

   select case(cmch)
    case('dstr')
       call moss_plot('dstr') 
       call data2dread(0,info) 
    case('data') 
       k1=iss 
       call data2dread(k1,info) 
    case('ecic') 
       call excinc2d(info) 
    case('test') 
!      write(6,'(a)') ' before moss_the2exp  test'                      
       call moss_the2exp(1,info) 
!      write(6,'(a)') ' after moss_the2exp  test'   
    case('dfdp') 
!      derivatives df                                                    
       call moss_the2exp(2,info) 
    case('subs') 
       text(1)='           source' 
       text(2)='         absorber' 
       text(3)='  detector window' 
       ch1=' ' 
       if(b_data) then 
        ch132=name_data 
       else 
        ch132=name_theory 
       end if 
       call chcenter(ch132,ch1,ncl) 
       cp132='plot of subspectra of' 
       call chcenter(cp132,ch1,ncl) 
       print '(a)',' ' 
       print '(a,/,a)', cp132(:ncl),ch132(:ncl) 
       ch132='subspectra /added subspectra of' 
       call chcenter(ch132,ch1,ncl) 
       write(nwr,'(/,a)') ch132(:ncl) 
       call moss_selsubspect(text) 
    case('subt') 
       text(1)='           source' 
       text(2)='         absorber' 
       text(3)='  detector window' 
       print '(a)',' ' 
       print '(a)',' ' 
       print '(a)','                     subtraction of subspectra' 
       call moss_selsubtract(text,isub) 
       call moss_subtract('moss',mi,isub,info) 
       k1=1 
       call moss_the2exp(k1,info) 
       call moss_plot('subt') 
       k1=0; k2=0 
       if(b_theory) k1=1 
       call xmosplo(k1,k2) 
    case('plex') 
      k1=0 
      if(b_theory) k1=1 
      k2=1  ! 0: only plot and return, 1: interactive plot 
      call xmosplo(k1,k2) 
    case('ple2') 
!      plot execute                                                      
       k1=2   ! update test 
       k2=1   ! 0: only plot and return, 1: interactive plot 
       call xmosplo(k1,k2) 
    case('ple3') 
!      plot execute                                                      
       k1=3   ! update fit 
       k2=1   ! 0: only plot and return, 1: interactive plot 
       call xmosplo(k1,k2) 
    case('dmod') 
!      display mode , filling of plotarray                               
       call moss_plot('dmod') 
    case('plot')
       if(b_theory) then 
        k1=3 
        call moss_the2exp(k1,info) 
        if(n_subset.gt.0) call moss_subspect('moss',mi,info)
       end if 
       call moss_plot('plot') 
    case('punc')                              
!      punch data and theory                                             
       k1=iss 
       call punch2d(k1,info) 
       cmch='dim2'
    end select

    return 
    END                                           
                                                                        
      subroutine sel_the2exp(cmch,n1,info)
      implicit none 
      character(len=4), intent(in):: cmch 
      integer,intent(in) :: n1 
      integer,intent(out):: info 
      integer       ien
      common/strLOC/ien(32) 
      if(cmch.eq.'moss') then 
        ien(32)=1 
        call moss_the2exp(n1,info)
      else if(cmch.eq.'stro') then 
        call strob_the2exp(n1,info) 
      end if 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
      subroutine moss_the2exp(n1,info) 
      use glbconst, only: maxfr1,maxfr2,maxn,maxthss,max8,icstrf,ivstrf,   &
                          infotext,enwr,nwr
      use comdat, only: mfpt,mxpt,b_theory,ichanks
      use comthe, only: real_fr,array_fr,thfk,dfdp,ddpk,ib_df,kana,ibmisfit
      implicit none
! *****************************************************************     
!     n1 = 0 error return                                               
!     n1 = 1 call of theory                                             
!     n1 = 2 derivatives                                                
!     n1 = 3 call of theory without mapping by the transformation       
!            matrices by EFFI (important for subspectra)                
! *****************************************************************     
     integer, intent(in) :: n1
     integer, intent(out)::info
     integer, parameter:: illc=3*(maxfr1+1+maxfr2+maxthss) 
     character(len=64) :: frthname 
     integer, parameter:: nl=18
     integer       mstruct1,istruct1,istruct2,i_array,                  &
                   ipt,iposLG,ipTHS,ipTH,ipTHyy,iaddr                               
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),i_array(illc),&
                   frthname(2),                                                 &
                   ipt,iposLG,ipTHS,ipTH,ipTHyy,iaddr(3)

!    in case of calculation of selfabsorption (ifrcase.eq.6) ffsource < f_source
!    otherwise ffsource=f_source
     real          ffsource
     integer       ibe,km,mvpt,mgpt,mdgpt,ien
     common/strLOC/ibe(2),km,mvpt,mgpt,mdgpt,ien(25),ffsource
                                                                       
     real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,th_dum, &
                   drive_mode,channels_vmax,flag_basis,c_nonlinear,     &
                   om_samp,Dsource,Dabsorber,sc2absorber,sc2aperture,dumcs,dum    
     common/acstrf/acsp,uthick_w,dum,flag_basis,unit_chi,channels,     &
                   vm_SC,convol,th_dum,drive_mode,channels_vmax,c_nonlinear,   &
                   om_samp,Dsource,Dabsorber,sc2absorber,sc2aperture,dumcs(icstrf-17)

                                                                       
     real    avsp,f_factor,base,bg_fraction,v_max,                     &
             channel_v0,geo,vnl,                                       &
             Daperture,d_absorber,d_source,dumvs                       
     common/avstrf/avsp,f_factor,base,bg_fraction,v_max,               &
             channel_v0,geo,vnl(nl),                                   &
             Daperture,d_absorber,d_source,dumvs(ivstrf-10-nl)            

     logical b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,            &
             b_channel_v0,b_geo,b_vnl,                                 &
             b_Daperture,b_dabsorber,b_dsource,b_dumvs
     common/bvstrf/b_vsp,b_f_factor,b_base,b_bg_fraction,b_v_max,      &
             b_channel_v0,b_geo,b_vnl(nl),         &
             b_Daperture,b_dabsorber,b_dsource,b_dumvs(ivstrf-10-nl)
                                                                       
     
     real, dimension(-640:640):: yth
     real, dimension(1320)    :: cosa,a_r
     real, dimension(:), allocatable, save:: velocity,geof,dfdgeo

     character(len=4):: enpr 
     integer jsum,nTHyy2 

     logical b_total,b_fresonant,b_nonlinear,b_scale,b_drive,b_misfit, &
             b_residual,b_align                                        
     real    dv,fa,ff,fresonant,h,hi,sumcosal,vn,y1,y2,y3
     integer i,j,k,ka,l,mode_drive,nchansp,nomsamp,icase                   

     call mapsub(0,0,0) 
!      icase=0 
      if(base.eq.0.) then 
        info=1 
        infotext(1)='<Mossbauer_spectrum>/parameter/global/base0' 
        infotext(2)='**error** base = 0 ' 
        infotext(3)=' ' 
        return 
      end if 

      nchansp=channels
      i=size(velocity)
      if(allocated(velocity).and.i.ne.nchansp+2) deallocate(velocity,geof,dfdgeo) 
      if (.not.allocated(velocity)) &
               allocate(velocity(0:nchansp+1),geof(nchansp),dfdgeo(nchansp))
      nomsamp=om_samp
      mode_drive=drive_mode 
      h=abs(channel_v0/channels_vmax-1.0)*10 
      if(h.gt.1.0.or.nchansp.gt.4*maxn.or.nchansp.gt.channels_vmax*4) then 
        write(infotext(3),'(a,i5,2(a,f8.2))')                           &
        'nchansp=',nchansp,' channels_vmax=',channels_vmax,             &
        ' channel_v0=',channel_v0                                       
        info=1+abs(10*h) 
        infotext(1)='<Mossbauer_spectrum>/global_pa/ch_vmax/ch_v0' 
        infotext(2)='**error** with one of the size of'//               &
                    ' channels,channels_vmax,channel_v0'
        infotext(3)=' '
        return 
       end if 
                                                                        
      icase=0                                                                  
      ka=ipTH+1 
      nTHyy2=ipTHyy*2 

      b_nonlinear=b_vnl(1)
      do j=2,nl
       b_nonlinear=b_nonlinear.or.b_vnl(j)
      end do    
      b_scale=b_v_max.or.b_channel_v0.or.b_nonlinear
      b_drive=b_geo.or.b_scale 
      b_align=b_Daperture.or.b_dabsorber.or.b_dsource 
      b_scale=b_scale.or.b_align
      b_fresonant=b_f_factor.or.b_bg_fraction
      b_drive=b_geo.or.b_scale 
                                                                        
 
      call mossbauer_tmre(b_total,info)
      if(info.gt.0)return 
!      fresonant=f_factor*(1.0-bg_fraction) see declaration of ffsource above
      fresonant=ffsource*(1.0-bg_fraction) 
      if(fresonant.gt.1.)write(nwr,'(2a)')'**fresonant** larger than 1'
      if(info.gt.0)return 

      if(b_drive)call drive(int(drive_mode),int(c_nonlinear),nchansp,mvpt,mgpt, &
                            mdgpt,mxpt,channels_vmax,channel_v0,v_max,geo,vnl,info)
      if(info.gt.0)return 
      do i=1,nchansp 
       velocity(i)=real_fr(mvpt+i)
       geof(i)    =real_fr(mgpt+i)
       dfdgeo(i)  =real_fr(mdgpt+i)
      end do
      velocity(0)=velocity(1)-(velocity(2)-velocity(1))
      velocity(nchansp+1)=velocity(nchansp)+(velocity(nchansp)-velocity(nchansp-1))
!      write(6,'(/,a,4i8,8f15.2)')'km,mvpt,mgpt,mdgpt,base=',&
!                                  km,mvpt,mgpt,mdgpt,base,v_max
!      write(6,'(a,4g12.4)')' geo=',geo
!      write(6,'(8f10.2)')(geof(i),i=1,nchansp,32)
!      write(6,'(8f10.2)')(velocity(i),i=1,nchansp,32)

    select case(n1)    
    case(1) 
!      -------------------calculation of thfk-----------------------  
       if(b_base.or.b_fresonant.or.b_drive.or.b_total.or.b_align)then 
        dv=abs(v_max)/float(km) 
                                                                        
         b_misfit=ibmisfit.eq.1 
                                                              
        if(nomsamp.gt.0) then 
!        cosine smearing and aperture effects for scalar index of       
!        refraction- Absorber perpendicular to the optical axis.        
!        write(6,'(a)')' nomsamp.gt.1'
         enpr=enwr(9) 
         do j =0,km 
          yth(j)=alog(-(real(array_fr(ka+j))-1.)) 
          yth(-j)=alog(-(aimag(array_fr(ka+j))-1.)) 
         end do 
         do k=1,km/4 
          yth(-km-k)=yth(-km) 
          yth(km+k) =yth(km) 
         end do 
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k) 
           call geometry(icase,nomsamp,Dsource,Dabsorber,d_source,d_absorber,  &
                         Daperture,sc2absorber,sc2aperture,geo,geof(j),enpr,&
                         cosa,a_r,jsum)

           ff=0.0 
!          if(j.eq.100)then
!           write(6,'(3i4,a,10f10.3)')icase,nomsamp,jsum,'=jsum cosa,a_R:'
!           write(6,'(8f10.3)')(cosa(i),i=1,jsum)                       
!          end if                                                       
          do l=1,jsum 
            vn=velocity(j)*cosa(l) 
            sumcosal=sumcosal+a_r(l) 
            hi=vn/dv 
            i=int(hi) 
!           thickness increases with 1/cos                              
            y1=exp(yth(i-1)/cosa(l)) 
            y2=exp(yth(i)/cosa(l)) 
            y3=exp(yth(i+1)/cosa(l)) 
            hi=hi-float(i) 
            fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)) 
            ff=ff+(1.-fa*fresonant)*a_r(l) 
           end do 
           thfk(j)=base*ff 
           ff=0. 
           if(b_misfit)then 
            do l=1,jsum 
             ff=ff+base*a_r(l) 
            end do 
            dfdp(j)=ff 
           end if 
          end do 
         end do 
         enwr(9)=enpr
        else 
!        no cosine smearing                                             
         do j =0,km 
          yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant) 
          yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant) 
         end do 

         do k=1,km/4 
          yth(-km-k)=yth(-km) 
          yth(km+k) =yth(km) 
         end do
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k) 
           vn=velocity(j) 
           hi=vn/dv 
           i=int(hi) 
           y1=yth(i-1)
           y2=yth(i)
           y3=yth(i+1)
           hi=hi-float(i) 
           ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)) 
           thfk(j)=ff*geof(j)
           if(b_misfit)then 
            dfdp(j)=base*geof(j) 
           end if 
          end do 
         end do 
        end if 
        do j=1,nchansp 
         real_fr(nTHyy2+j)=thfk(j) 
        end do 
       else 
        do j=1,nchansp 
         thfk(j)=real_fr(nTHyy2+j) 
        end do 
       end if 
!      write(6,'(4e15.6)') (thfk(j),j=1,nchansp,64)  
       b_theory=.true. 

         if(enwr(16).eq.'sint') then
          y1=0.
          y2=0.0
          do k=2,ichanks(0),2 
           do j=ichanks(k-1),ichanks(k) 
            y1=y1+real_fr(mfpt+j)-thfk(j)
            y2=y2+(base*geof(j)-thfk(j))
           end do 
          end do 
          print'(a,f10.3)',' (theory-exp)/total_intensity:',y1/y2*100
         end if


  case(2)
!     ----------------------------derivatives----------------------
!     write(6,'(a,f15.5)') ' derivative step=',ddpk                     
      dv=abs(v_max)/float(km) 
!     write(6,'(a,10L4)')'b_base,b_geo,b_scale,b_fresonant,b_f_factor=',  &
!                    b_base,b_geo,b_scale,b_fresonant,b_f_factor  
      ib_df=0 
      kana=0 
      do j=1,nchansp 
       thfk(j)=real_fr(nTHyy2+j) 
      end do 
!     parameter pl(j)                                                   
                                                                        
!     variable pl(1)                                                    
      if(b_base) then 
       b_residual=b_geo.or.b_scale.or.b_fresonant 
       if(b_residual) then 
        goto 240 
       else 
!        write(6,'(a,f10.1)')  'derivative of base -----base=',base     
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
          dfdp(j)=thfk(j)/base 
         end do 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
       end if 
      end if 
                                                                        
!     variable pl(3)                                                    
      if(b_geo) then 
       b_residual=b_base.or.b_scale.or.b_fresonant 
       if(b_residual) then 
        goto 240 
       else 
!       write(6,'(a)')  '   derivative of geo ------------'             
!       in case of cosine smearing this derivation is approximate       
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
          dfdp(j)=dfdgeo(j)*thfk(j) 
         end do 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
       end if 
      end if 
                                                                        
      if(b_fresonant) then 
       if(b_bg_fraction.and.b_f_factor) then 
        write(nwr,'(a)')                                                &
        '**correlation_1** bg_fraction,f_factor are correlated by 1' 
       end if 
       if(b_bg_fraction) then 
!       variable pl(2)                                                  
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
          dfdp(j)=-(thfk(j)-base*geof(j))/(1.0-bg_fraction) 
         end do 
        end do 
        kana=1 
        ib_df=1 
        goto 250 
       end if 
                                                                        
       if(b_f_factor) then 
!      variable pl(2)                                                   
        b_residual=b_base.or.b_geo.or.b_scale.or.b_bg_fraction 
        if(b_residual) then 
         goto 240 
        else 
!        write(6,'(a)')  '   derivative of f_factor ------------'       
!        in case of cosine smearing this derivation is approximate      
         do k=2,ichanks(0),2 
          do j=ichanks(k-1),ichanks(k) 
           dfdp(j)=(thfk(j)-base*geof(j))/f_factor 
          end do 
         end do 
         kana=1 
         ib_df=1 
         goto 250 
        end if 
       end if 
      end if 
                                                                        
  240 kana=0 
      if(nomsamp.gt.0) then 
!      cosine smearing and aperture effects                             
       do j =0,km 
        yth(j)=alog(-(real(array_fr(ka+j))-1.)) 
        yth(-j)=alog(-(aimag(array_fr(ka+j))-1.)) 
       end do 
       do k=1,km/4 
        yth(-km-k)=yth(-km) 
        yth(km+k) =yth(km) 
        end do 
                                                                        
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
          call geometry(icase,nomsamp,Dsource,Dabsorber,d_source,d_absorber, &
                        Daperture,sc2absorber,sc2aperture,geo,geof(j),enpr,&
                        cosa,a_r,jsum)
          ff=0.0 
          do l=1,jsum 
           vn=velocity(j)*cosa(l) 
           hi=vn/dv 
           i=int(hi) 
           y1=exp(yth(i-1)/cosa(l)) 
           y2=exp(yth(i)/cosa(l)) 
           y3=exp(yth(i+1)/cosa(l)) 
           hi=hi-float(i) 
           fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)) 
           ff=ff+(1.-fa*fresonant)*a_r(l) 
          end do 
          dfdp(j)=(base*ff-thfk(j))/ddpk 
         end do 
        end do   ! j=1,nchansp 
       else 
!       no cosine smearing                                              
        do j =0,km 
         yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant) 
         yth(-j)=base*(1.-(1.-aimag(array_fr(ka+j)))*fresonant) 
        end do 
        do k=1,km/4 
         yth(-km-k)=yth(-km) 
         yth(km+k) =yth(km) 
        end do 
        do k=2,ichanks(0),2 
         do j=ichanks(k-1),ichanks(k) 
          vn=velocity(j) 
          hi=vn/dv 
          i=int(hi) 
          y1=yth(i-1) 
          y2=yth(i) 
          y3=yth(i+1) 
          hi=hi-float(i) 
          ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)) 
          dfdp(j)=(ff*geof(j)-thfk(j))/ddpk 
         end do 
        end do       ! j=1,nchansp 
       end if 
       ib_df=1 
                       
  250 continue 
!      write(6,'(4e15.6)') (dfdp(i),i=1,nchansp,32) 
  case(3)                                                                      
    if(b_theory)then
     if(b_base.or.b_fresonant.or.b_drive.or.b_total.or.b_align)then 
      dv=abs(v_max)/float(km) 
!     this label address is used for the calculation of subspectra      
                                                                        
      if(nomsamp.gt.0) then 
!      cosine smearing and aperture effects                             
       do j =0,km 
        yth(j)=alog(-(real(array_fr(ka+j))-1.)) 
        yth(-j)=alog(-(aimag(array_fr(ka+j))-1.)) 
       end do 
       do k=1,km/4 
        yth(-km-k)=yth(-km) 
        yth(km+k) =yth(km) 
       end do 
        do j=1,nchansp 
         call geometry(icase,nomsamp,Dsource,Dabsorber,d_source,d_absorber, &
                       Daperture,sc2absorber,sc2aperture,geo,geof(j),enpr,&
                       cosa,a_r,jsum)
         ff=0.0 
         do l=1,jsum 
          vn=velocity(j)*cosa(l) 
          hi=vn/dv 
          i=int(hi) 
          y1=exp(yth(i-1)/cosa(l)) 
          y2=exp(yth(i)/cosa(l)) 
          y3=exp(yth(i+1)/cosa(l)) 
          hi=hi-float(i) 
          fa=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)) 
          ff=ff+(1.-fa*fresonant)*a_r(l) 
         end do 
         thfk(j)=base*ff 
        end do 
      else 
!      no cosine smearing                                               
       do j =0,km 
        yth(j)=base*(1.-(1.-real(array_fr(ka+j)))*fresonant) 
        yth(-j)=base*(1.-fresonant*(1.-aimag(array_fr(ka+j)))) 
       end do 

       do k=1,km/4 
        yth(-km-k)=yth(-km); yth(km+k) =yth(km) 
       end do 
        do j=1,nchansp 
         vn=velocity(j) 
         hi=vn/dv 
         i=int(hi) 
         y1=yth(i-1) 
         y2=yth(i) 
         y3=yth(i+1) 
         hi=hi-float(i) 
         ff=y2+0.5*hi*(y3-y1+hi*(y1+y3-2.*y2)) 
         thfk(j)=ff*geof(j) 
        end do 
       end if 
      else    
       do j=1,nchansp 
        thfk(j)=real_fr(nTHyy2+j) 
       end do                           
      end if

     end if
   end select 
   return
   END                                           
                                                                        
!     H. Spiering January,1995 Mainz                                    
!                 oktober 2004 Budapest, Dezember Christcurch           
!                 June Mainz 2005                                       
!     moving absorber or moving source                                  
!                                                                       
     subroutine mossbauer_tmre(b_total,info) 
     use glbconst, only: maxfr1,maxfr2,maxn,maxscrd,maxthss, &
                         ivstrf,ivfr1trf,ivfr2trf,ivsstrf, &
                         icstrf,icfr1trf,icfr2trf,icsstrf,enwr,nwr,nrd
     use comstr, only: nu_device
     use comthe, only: array_fr,ifrcase,lstr1case
     implicit none 
     logical, intent(out):: b_total 
     integer, intent(out):: info

     integer       mstruct1,istruct1,istruct2,l1_get,l2_get,l3_get,    &
                   l1_put,l2_put,l3_put,ipt,iposLG,ipTHS,ipTH,iaddr
     character(len=4) :: c1_prp,c2_prp,c3_prp
     character(len=64):: frthname 
     common/struct/mstruct1,istruct1(0:maxfr1),istruct2(0:maxfr2),     &
                   l1_get(0:maxfr1),l2_get(maxfr2),l3_get(maxthss),    &
                   l1_put(0:maxfr1),l2_put(maxfr2),l3_put(maxthss),    &
                   c1_prp(0:maxfr1),c2_prp(maxfr2),c3_prp(maxthss),    &
                   frthname(2),                                        &
                   ipt,iposLG,ipTHS,ipTH,iaddr(4)

     real          ffsource
     integer       ifrth,km,idum,nAS,nSC,ien
     common/strLOC/ifrth(2),km,idum(12),nAS,nSC,ien(14),ffsource                   
                                                                       
     real          acsp,uthick_w,unit_chi,channels,vm_SC,convol,       &
                   th_dum,drive_mode,channels_vmax,dumcs,dum           
     common/acstrf/acsp,uthick_w,dum(2),unit_chi,channels,vm_SC,convol,&
                   th_dum,drive_mode,channels_vmax,dumcs(icstrf-11)    
     real           avsp,f_factor,base,bg_fraction,dumvs
     common/avstrf/avsp,f_factor,base,bg_fraction,dumvs(ivstrf-4) 
                                                                       
     logical       b_vsp,b_v_max,b_dumvsp 
     common/bvstrf/b_vsp(4),b_v_max,b_dumvsp(ivstrf-5) 
                                                                       
     real            avfr1,devfactor, devHext,devthetaHe,devphiHe,     &
                     dvfr1                                             
     common/avfr1trf/avfr1,devfactor,devHext,devthetaHe,devphiHe,      &
                     dvfr1(ivfr1trf-5)                                 
     logical         b_vfr1,b_devfactor,b_devHext,b_devthetaHe,        &
                     b_devphiHe,b_dvfr1                                
     common/bvfr1trf/ b_vfr1,b_devfactor,b_devHext,b_devthetaHe,       &
                      b_devphiHe,b_dvfr1(ivfr1trf-5)                   
                                                                       
     real            acfr2,dumcfr2 
     common/acfr2trf/acfr2,dumcfr2(icfr2trf-1) 
                                                                       
!                    phi,theta,psi are not directly assigned           
!                    but by arry_fr via the routine orientation        
     real            avfr2,th_factor,dumx,Hext,thetaHe,phiHe,          &
                     phi,theta,psi,dumvfr2                             
     common/avfr2trf/avfr2,th_factor,dumx(4),Hext,thetaHe,phiHe,       &
                     phi,theta,psi,dumvfr2(ivfr2trf-12)                
     logical         b_vfr2,b_thfactor,b_dumx,b_phi,b_theta,b_psi,     &
                     b_dumvfr2                                         
     common/bvfr2trf/b_vfr2,b_thfactor,b_dumx(7),b_phi,b_theta,b_psi,  &
                     b_dumvfr2(ivfr2trf-12)                            
                                                                       
     real            vsstrf,sftr 
     common/avsstrf/ vsstrf(ivsstrf) 
     logical         b_vsstrf,b_not_sftr 
     common/bvsstrf/ b_vsstrf(ivsstrf) 
                                                                       
     integer, parameter:: mAS=4*maxn,                             &
                         idumscrd=maxscrd-9*(2*mAS+1)                 
     real        sTr,sP1,sP2,sP3,aTr,aP1,aP2,aP3,sa,dumscrd 
     common/scrd/sTr(-mAS:mAS),sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),&
                 aTr(-mAS:mAS),aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),&
                 sa(-mAS:mAS),dumscrd(idumscrd)       
     complex     yout(0:512) 
                                                                       
     logical   b_source,b_absorber,b_detector,b_lay,                   &
               b_polabsorber,b_polsource,b_absdetector,b_reemission 
     logical,dimension(maxfr1)    :: b_device 
     logical,dimension(maxfr2)    :: b_module
     logical,dimension(0:maxthss) :: b_polisite

     integer   icase,issa,isse,idt,i,j,n,na,nn,n8,n2,mfr1,nspdv,             &
               k,lay,layb,layl,nabs0,nabs1,nabs2,nabs3,                &
               npolSCAS,iyout,isubthe,                                 &
               lstruct1,lstruct2,lstruct3,iget,isite,isource        

     real      satrexpr,factor_thickness,h,wixf,hnorm,attenuation
     real,dimension(maxfr1) :: areafrac
     real,dimension(maxthss):: wi

     complex  app,apm,amp,satraceh
     complex,dimension(4,maxfr2):: aam
     complex,dimension(4)::  aa,bb,dd                         
     complex(kind=8),dimension(4)::  daa,dbb,dcc
     real, dimension(:), allocatable :: detector 
     complex, parameter:: C0=cmplx(0.0,0.0), hci=cmplx(0.0,1.0), hc1=cmplx(1.,0.)   
     character(len=132) :: querytype,chcom
     character(len=1):: ch1
     
      allocate(detector(-nSC:nSC))

      do i=1,maxthss 
       wi(i)=0. 
      end do 
!     ch_case='source','absorber','detector',                           
!     ifrcase=3 transmission, 4 reemission                              
!     ifrcase=5   incoherent absorber                                   
                                                                        
      b_reemission=.false. 
      if(ifrcase.eq.2.or.ifrcase.eq.4) b_reemission=.true. 
      b_polsource  =.false. 
      b_polabsorber=.false. 
                                                                        
       b_source =.false. 
       b_absorber=.false. 
       b_detector=.false. 
       b_absdetector=.false. 
!------------------------------------------------------------------     
!-------------------------------------------------------------------    
                                                                        
      b_total=b_v_max 
      isubthe=1 
      call get_theory(isubthe,info) 
      if(info.gt.0) goto 1000 
      b_total= b_total.or.(isubthe.gt.0) 
!      write(6,'(a,i3)')'ifrcase=',ifrcase                              
!      write(6,'(a,i3)')'mstruct1=',mstruct1                            
!      write(6,'(a,10i3)')'istruct1=',(istruct1(i),i=0,5)               
!      write(6,'(a,10i3)')'istruct2=',(istruct2(i),i=0,5)               
                                                                        
      do lstruct1=1,mstruct1 
       b_device(lstruct1)=.false.                                    
       call mapsub(lstruct1,0,0) 
       isubthe=1     ! frame   
       call get_theory(isubthe,info) 
       if(info.gt.0) goto 1000 
       b_total= b_total.or.(isubthe.gt.0) 
                                                                        
       if(nu_device(lstruct1).eq.1) then 
        lstr1case=1     ! entry for the source is transferred by the 
!                         common block  'common/struct/' to the         
!                         the routine called by get_theory              
!                         the subroutine th_..index..() branches to     
!                         source,absorber,detector by the command       
!                         goto (100,200,300),lstr1case                  
!      -----------------------------------------------------------------
!      layer 1 = source                                          
!      -----------------------------------------------------------------
!      Sums of source curves at the positions Eagd. For the convolution 
!      integral the stepwidth is srw2. The stepwidth srw8 of the  
!      source function guarantees that the source line is exact         
!      within 1/8 channel(flag_SAMP=1).                                              
!                                                                     
!      ----0--------------------------nLG                               
!       nLG--------------------------0-------------        srw8         
!        nSC------------0------------nSC                    srw2        

        if(ifrcase.eq.6)then
         do i=1,4*(2*nSC+1)
          array_fr(ipTHS+i)=C0
         end do
        end if
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 

         call mapsub(lstruct1,lstruct2,0) 
         isubthe=1 
         call get_theory(isubthe,info) 
         if(info.gt.0) goto 1000 
         if(isubthe.le.0) then 
!          b_phi=.false. 
          phi=0.0 
          theta=0.0 
          psi=0.0 
         else 
          iget=l2_get(lstruct2) 
          b_phi=aimag(array_fr(iget+2)).gt.0.0 
          phi  =real(array_fr(iget+2)) 
          theta=real(array_fr(iget+3)) 
          psi  =real(array_fr(iget+4)) 
         end if 
         b_lay=(isubthe.gt.0).or.b_phi.or.b_thfactor 
 
         issa=istruct2(lstruct2-1)+1                                                               
         isse=istruct2(lstruct2)
         do lstruct3=issa,isse
          call mapsub(lstruct1,lstruct2,lstruct3) 

          ! if one site of the source is polarized all sites
          ! need the full 2x2 matrices 
          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs' 
          if(b_polisite(lstruct3)) b_polsource=.true.
                                                                        
          if(th_factor.gt.0.) then
           wi(lstruct3)=vsstrf(2)*th_factor 
          else
            wi(lstruct3)=vsstrf(2)
          end if 

          isubthe=0   
          call get_theory(isubthe,info) 
          if(info.gt.0) goto 1000 
          b_source=b_source.or.b_lay.or.(isubthe.gt.0).or.b_vsstrf(1) 
          if(ifrcase.eq.6)then
           ! the density matrices of the sites of the source are summed up
           ! at the storage area of the first site
           isource=l3_get(lstruct3) 
           icase=real(array_fr(ipTHS+4*(2*nSC+1)+1))
           if(icase.gt.1) then
            wixf=wi(lstruct3)*f_factor
            do i=-nSC,nSC
             na=ipTHS+4*(i+NSC)
             nn=isource+6*(i+NSC)
             array_fr(na+1)=array_fr(na+1)+array_fr(nn+3)*wixf
             array_fr(na+2)=array_fr(na+2)+array_fr(nn+4)*wixf
             array_fr(na+3)=array_fr(na+3)+array_fr(nn+5)*wixf
             array_fr(na+4)=array_fr(na+4)+array_fr(nn+6)*wixf
            end do
           end if
          end if
         end do  ! lstruct3 
        end do   ! lstruct2
        b_device(1)=b_source 
       end if ! (nu_device(lstruct1)=1 source
                                                                        
                                                                        
       if(nu_device(lstruct1).eq.2) then 
!       ----------------------------------------------------------------
!       layer lay2,3 ... mlay of  absorber at rest                      
!       ----------------------------------------------------------------
!       The Lorentz curve of the absorber in npq is 1 at resonance so th
!       for a singl line the exponent at resonance is just -teff (effect
!       thickness). areaLor ~ pi*ga/2 ( area -+ infinity), ga/2=hga/2/sr
!       normalizes ( to area 1) the Lorentz curve.                      
                                                                        
!       Sums of absorber curves at the positions Eagd. For the convoluti
!       integral the stepwidth is still srw4. The stepwidth srw8 of the 
!       absorber function guarantees that the absorbtion line is exact  
!       within 1/4 channel.                                             
!                                                                       
!       ----0--------------------------naLG                             
!       naLG--------------------------0-------------        srw8        
!        nAS------------0------------nAS                    srw2        
        lstr1case=2       ! device=absorber 
        phi=0.; theta=0. ; psi=0. 
                                                              
        if(ifrcase.eq.5)then 
         areafrac(lstruct1)=devfactor 
         b_device(lstruct1)=b_devfactor 
!        rotation of the absorber, the same for all layers              
         call mapsub(lstruct1,0,0) 
         isubthe=1 
         call get_theory(isubthe,info) 
         if(info.gt.0) goto 1000 
         if(isubthe.eq.0) then 
          b_phi=.false. 
         else 
          iget=l1_get(lstruct1) 
                                                    !                   
          b_phi=aimag(array_fr(iget+2)).gt.0.0 
          phi  =real(array_fr(iget+2)) 
          theta=real(array_fr(iget+3)) 
          psi  =real(array_fr(iget+4)) 
         end if 
!         write(6,'(2i6,a,3f10.2)')lstruct2,iget,      &                     
!         '  mossbauer phi,theta,psi=',phi,theta,psi                   
                                                                        
!        the external field is the same for all layers of device2=absorb
!        for all mosaic parts of the absorber -> transfer of variables  
!        and logical from common/uvfr1trf/ to common/uvfr2trf/ (u=a,b). 
         Hext=devHext 
         thetaHe=devthetaHe 
         phiHe=devphiHe 
         b_dumx(5)=b_devHext 
         b_dumx(6)=b_devthetaHe 
         b_dumx(7)=b_devphiHe 
        end if 
                                                                        
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
                                                                        
         b_lay=.false. 
          call mapsub(lstruct1,lstruct2,0) 
          isubthe=1 
          call get_theory(isubthe,info) 
          if(info.gt.0) goto 1000 
         if(ifrcase.ne.5)then 
          if(isubthe.eq.0) then 
           b_phi=.false. 
          else 
!          write(6,'(a,i1,a2,i6)')                                      
!     &     'l2_get(',lstruct2,')=',l2_get(lstruct2)                    
           iget=l2_get(lstruct2) 
           b_phi=aimag(array_fr(iget+2)).gt.0.0 
           phi  =real(array_fr(iget+2)) 
           theta=real(array_fr(iget+3)) 
           psi  =real(array_fr(iget+4)) 
!          write(6,'(2i6,a,3f10.2)')lstruct2,iget,            &
!          '  mossbauer phi,theta,psi=',phi,theta,psi                   
          end if
 
          b_lay= b_lay.or.b_phi.or.(isubthe.gt.0) 
         end if 
                                                                        
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
          b_polisite(lstruct3)=c3_prp(lstruct3).eq.'plrs' 
          if(b_polisite(lstruct3)) b_polabsorber=.true. 
                                                                        
          call mapsub(lstruct1,lstruct2,lstruct3) 
                                                                        
          sftr=vsstrf(2) 

!         logical of the thickness sftr is at b_vsstrf(2)               
          if(ifrcase.eq.3.or.ifrcase.eq.5) then 
           factor_thickness=real(array_fr(iget+1)) 
           wi(lstruct3)=sftr*uthick_w*factor_thickness 
           if(th_factor.gt.0.001) then 
            wi(lstruct3)=wi(lstruct3)*th_factor 
            b_lay=b_lay.or.b_thfactor.or.b_vsstrf(2)
           end if 
          else 
           wi(lstruct3)=sftr*uthick_w 
           if(th_factor.gt.0.001) then 
            wi(lstruct3)=wi(lstruct3)*th_factor 
            b_lay= b_lay.or.b_thfactor.or.b_vsstrf(2) 
           end if 
          end if 
          isubthe=0 
          call get_theory(isubthe,info) 
          if(info.gt.0) goto 1000 
!          write(6,'(a)')' th_mossbauer absorber 2'                     
!          write(6,'(10f10.3)')(vsstrf(i),i=1,10)                       
          b_lay= b_lay.or.b_vsstrf(2).or.(isubthe.gt.0) 
         end do 
          b_module(lstruct2)=b_lay 
          b_device(lstruct1)=b_device(lstruct1).or.b_lay 
        end do 
       end if  !  nu_device(lstruct1)=2 absorber 
       b_absorber=b_absorber.or.b_device(lstruct1) 
       b_phi=.false.                                                                 
                                                                        
       if(nu_device(lstruct1).eq.3) then 
        lstr1case=3 
!      ---------------------------------------------------------------- 
!      layer lay=mlay of detector                                       
!      ---------------------------------------------------------------- 
        do n=-nSC,nSC 
         detector(n)=0. 
        end do 
        b_absdetector=.true. 
        do lstruct2=istruct1(lstruct1-1)+1,istruct1(lstruct1) 

         lay=lstruct2 
         do lstruct3=istruct2(lstruct2-1)+1,istruct2(lstruct2) 
                                                                        
          call mapsub(lstruct1,lstruct2,lstruct3) 
          j=vsstrf(1) 
          do k=3,j+1 
           b_not_sftr=b_not_sftr.or.b_vsstrf(k) 
          end do 
                                                                        
          sftr=vsstrf(2) 
          wi(lstruct3)=sftr*uthick_w 
                                                                        
          isubthe=0 
          call get_theory(isubthe,info) 
          if(info.gt.0) goto 1000 
                                                                        
          b_detector=b_not_sftr                                         &
                         .or.b_vsstrf(2).or.(isubthe.gt.0)              
                                                                        
          idt=l3_get(lstruct3)+1 
!         write(6,'(a,i6)') 'iget=idt=',idt                             
          do n=0,nSC 
           detector(n)=detector(n)+real(array_fr(idt+n))*wi(lstruct3) 
           detector(-n)=detector(-n)+aimag(array_fr(idt+n))*wi(lstruct3) 
          end do  ! n=0,nSC  
          do n=-nSC,nSC 
           detector(n)=exp(-2.*detector(n)) 
          end do  ! n=0,nSC   
         end do 
        end do 
        b_device(lstruct1)=b_detector 
       end if  !  nu_device(lstruct1)=3 detector 
  
      end do 
      b_total=b_total.or.b_source.or.b_absorber.or.b_detector 

!-----------------------------------------------------------------------
!      here the matrix R for the absorber are given :                   
!      satrace(n)*1 +  (sapp(n)  sapm(n))                               
!                      (samp(n) -sapp(n))                               
!                                                                       
!      calculation of the transmittivity matrix T for all channels n    
!      by   T = exp(iR)*rho*exp(-iR+)                                   
!      exp(-2*Sum;lay sattrlay(lay)) is a common factor, which is the   
!      only one for an unpolarized sample                               
                                                                        
!-----------------------------------------------------------------------
!      here the matrix R for the layers are given :                     
!      satrlay(n,lay)*1 +  (sapplay(n,lay)  sapmlay(n,lay))             
!                          (samplay(n,lay) -sapplay(n,lay))             
!                                                                       
!      calculation of the transmittivity matrix T for all channels n    
!      by   T = exp(iR)*rho*exp(-iR+)                                   
!      exp(-2*Sum;lay sattrilay(lay)) is a common factor, which is the  
!      only one for an unpolarized sample                               
!      if(mstrut1.eq.3) then the last layer (detector) does not move rel
!      to the source. The detector window is treated as an unpolarized a
                                                                        
       if(enwr(15).eq.'tota')print'(a,4l5)',  &
       'moss b_source,b_absorber,b_total=',b_source,b_absorber,b_total 
                                                                        
      ffsource=f_factor
      hnorm=1
      if(.not.b_total) goto 1000 
                                                                        
      iyout=ipTH+1 
      do k=0,km 
       array_fr(iyout+k)=cmplx(1.,1.) 
      end do 
                                                                        
      mfr1=mstruct1 
      if(nu_device(mstruct1).eq.3)mfr1=mfr1-1 
                                                                        
      do lstruct1=2,mfr1 
       if(b_device(lstruct1)) then 
                                                                        
        do n=-nAS,nAS 
         n2=2*abs(n)+1 
         if(n.ge.0) n2=n2-1 
         n8=4*n2 
                                                                        
         satraceh=cmplx(0.,0.) 
         do lay=istruct1(lstruct1-1)+1,istruct1(lstruct1) 
          issa=istruct2(lay-1)+1 
          isse=istruct2(lay) 
          app=cmplx(0.,0.) 
          apm=cmplx(0.,0.) 
          amp=cmplx(0.,0.) 
          if(isse.gt.issa) then 
           do isite=issa,isse 
!           if(n.eq.0)write(6,'(a ,2i4,2x,f10.4)')   &                   
!            ' --1-lay,isite,wi(isite)=',lay,isite,wi(isite)             
            if(b_polisite(isite)) then 
             nn=l3_get(isite)+n8 
!            if(n.eq.0)write(6,'(a,2i6)') 'iget=',l3_get(isite),nAS     
             app=app+array_fr(nn+2)*wi(isite) 
             apm=apm+array_fr(nn+3)*wi(isite) 
             amp=amp+array_fr(nn+4)*wi(isite) 
            else 
             nn=l3_get(isite)+n2 
!             if(n.eq.0)write(6,'(a,i6)') 'iget=',l3_get(isite)         
            end if 
            satraceh=satraceh+array_fr(nn+1)*wi(isite) 
!            if(abs(n).lt.2) write(6,'(2i6,11f8.3)')&                    
!             n,nn,wi(isite),satraceh*1000                             
                      ! isite loop                                      
           end do 
          else 
!          if(n.eq.0)write(6,'(a ,2i4,2x,f10.4)')  &                     
!           ' --2-lay,issa,wi(issa)=',lay,issa,wi(issa)                  
           if(b_polisite(issa)) then 
            nn=l3_get(issa)+n8 
            app   =  array_fr(nn+2)*wi(issa)
            apm   =  array_fr(nn+3)*wi(issa) 
            amp   =  array_fr(nn+4)*wi(issa) 
!           if(n.eq.0)write(6,'(a ,2i8,3i4,2x,f10.4)')  &                
!          '1-lay,issa,wi(issa)=',l3_get(issa),l3_get(issa)+8*nAS, &     
!           lstruct1,lay,issa,wi(issa)
           else 
            nn=l3_get(issa)+n2 
           end if 
           satraceh=satraceh+array_fr(nn+1)*wi(issa) 
          end if  ! isse.gt.issa  
                                                                        
          if(b_polabsorber) then 
           if(b_reemission) then 
            aa(1)=cmplx(1.0,0.0)+app 
            aa(3)=apm 
            aa(2)=amp 
            aa(4)=cmplx(1.0,0.0)-app 
           else 
            call expo_22(app,apm,amp,aa) 
           end if 
           do k=1,4 
            aam(k,lay)=aa(k) 
           end do 
          end if 
         end do   ! lay
                                                                        
         if(b_reemission) then 
          satrexpr=1.0+2.*aimag(satraceh) 
         else 
          satrexpr=exp(-aimag(satraceh)*2.)
         end if 
!         if(abs(n).le.5) write(6,'(i2,3f12.6,5x,L5)') &                 
!                 n,satraceh,satrexpr,b_polabsorber 
                                                                          
         layl=istruct1(lstruct1) 
         layb=istruct1(lstruct1-1)+1 
         if(b_polabsorber) then 
          do k=1,4 
           dd(k)=aam(k,layl) 
          end do 
                                                                        
!         multiplication of the matrices exp(iR(layl))*...*exp(iR(2))   
          if(layl.gt.2) then 
           do k=1,4 
            dcc(k)=dcmplx(dd(k)) 
           end do 
           do lay=layl-1,layb,-1 
            do k=1,4 
             daa(k)=dcc(k) 
             dbb(k)=dcmplx(aam(k,lay)) 
            end do 
            call matproD(daa,dbb,dcc) 
           end do 
           do k=1,4 
            dd(k)=dcc(k) 
           end do 
          end if 
!          if(n.eq.0) write(6,'(a,11f8.3)')' dd=',dd                    
!         trace (dd+*dd*rho) is the intensity                           
!         bb=cc+                                                        
          bb(1)=conjg(dd(1)) 
          bb(4)=conjg(dd(4)) 
          bb(2)=conjg(dd(3)) 
          bb(3)=conjg(dd(2))
                                                                        
          call matprof(bb,dd,aa)
 
!         aa=cc*cc+ is a Hermitian matrix                               
!         aa=1/2*trace(aa)*1 + aP*sv(Pauli)                             
          aa(1)=aa(1)*satrexpr 
          aa(2)=aa(2)*satrexpr 
          aa(4)=aa(4)*satrexpr 
          aTr(n)= 0.5*real(aa(1)+aa(4))-1. 
          aP1(n)=  real(aa(2)) 
          aP2(n)= aimag(aa(2)) 
          aP3(n)= -0.5*real(aa(1)-aa(4))      ! ? 4.10.2015
         else 
          aTr(n)= satrexpr-1. 
          aP1(n)=0.0 
          aP2(n)=0.0 
          aP3(n)=0.0 
         end if 
        end do ! n  

        nabs0=l1_put(lstruct1)+1 
        if(b_polabsorber.and.b_polsource) then 
         nabs1=nabs0+nAS+1 
         nabs2=nabs1+nAS+1 
         nabs3=nabs2+nAS+1 
         do n=0,nAS 
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n)) 
          array_fr(nabs1+n)=cmplx(aP1(n),aP1(-n)) 
          array_fr(nabs2+n)=cmplx(aP2(n),aP2(-n)) 
          array_fr(nabs3+n)=cmplx(aP3(n),aP3(-n)) 
         end do 
        else 
         do n=0,nAS 
          array_fr(nabs0+n)=cmplx(aTr(n),aTr(-n)) 
         end do 
        end if 
       else  ! b_device(lstruct1) 
        nabs0=l1_put(lstruct1)+1              ! 25.7.06  
        if(b_polabsorber.and.b_polsource) then 
         nabs1=nabs0+nAS+1 
         nabs2=nabs1+nAS+1 
         nabs3=nabs2+nAS+1 
         do n=0,nAS 
          aTr(n) = real(array_fr(nabs0+n)) 
          aP1(n) = real(array_fr(nabs1+n)) 
          aP2(n) = real(array_fr(nabs2+n)) 
          aP3(n) = real(array_fr(nabs3+n)) 
          aTr(-n)=aimag(array_fr(nabs0+n)) 
          aP1(-n)=aimag(array_fr(nabs1+n)) 
          aP2(-n)=aimag(array_fr(nabs2+n)) 
          aP3(-n)=aimag(array_fr(nabs3+n)) 
         end do 
        else 
         do n=0,nAS 
          aTr(n) = real(array_fr(nabs0+n)) 
          aTr(-n)=aimag(array_fr(nabs0+n)) 
         end do 
        end if 
       end if       ! b_device(lstruct1)
                                                                        
       nspdv=l1_put(lstruct1)+4*(nAS+1)+1 
       do k=0,km 
        array_fr(nspdv+k)=(0.,0.) 
       end do

      if(ifrcase.eq.6)then
       sTr=0
       lay=1 
       issa=istruct2(lay-1)+1 
       isse=istruct2(lay) 
!       h1=0.
       do isite=issa,isse 
!       sum over all source sites                                       
        isource=l3_get(isite) 
!       write(6,'(a,2i6)') 'isite,iget=isource=',isite,isource
        if(enwr(7).eq.'scrv')then
         call rhoz_reverse(isource,ipTHS,nSC,mAS,sTr,sP1,sP2,sP3,attenuation)
        else
         call rhoz(isource,ipTHS,nSC,mAS,sa,sP1,sP2,sP3,attenuation)
        end if
!        hnorm=0. 
!        do n=-nSC+1,nSC-1,2 
!         hnorm=hnorm+ sa(n)*2 
!        end do 
!        do n=-nSC+2,nSC-2,2 
!         hnorm=hnorm+sa(n) 
!        end do 
!        hnorm=hnorm*2.+ sa(-nSC)+sa(nSC); hnorm=hnorm/3
!        h1=h1+hnorm*wi(isite)
        
        do n=-nSC,nSC 
         sTr(n)=sTr(n)+sa(n)*wi(isite) 
        end do

       end do                                                                 
       hnorm=0. 
       do n=-nSC+1,nSC-1,2 
        hnorm=hnorm+ sTr(n)*2 
       end do 
       do n=-nSC+2,nSC-2,2 
        hnorm=hnorm+sTr(n) 
       end do 
       hnorm=hnorm*2.+ sTr(-nSC)+sTr(nSC); hnorm=hnorm/3
!      Normierung: 2/(Gamma*pi)*srw*h1=1

       h=hnorm*f_factor+(1-f_factor)*attenuation
       ffsource=f_factor*hnorm/h
       if(enwr(15).eq.'scef')then
        querytype='interpretation of variables Ir,Inr,f_eff, and  bg_fr' 
        chcom='<Mossbauer_spectrum>/attenuation' 
        print'(a,2f6.3,a,f6.3,a,f5.3,/)',' Ir,Inr=',hnorm,attenuation,   & 
                          '    f_eff=',ffsource
        ch1='n'
        nn=80
        call yesno(querytype,ch1,chcom,nn,nrd,nwr)
        if(ch1.eq.'y')call help(chcom)
        enwr(15)='nnnn'
       end if

      end if 


      lay=1 
      issa=istruct2(lay-1)+1 
      isse=istruct2(lay) 
                                                                        
      do isite=issa,isse 
!      sum over all source sites                                       
       isource=l3_get(isite) 

!      write(6,'(a,f10.2,2i6)') 'wi(isite) isite,iget=isource=',wi(isite),isite,isource
       factor_thickness=wi(isite) 
       b_polsource=b_polisite(isite) 
       if(factor_thickness.gt.0)then

        if(ifrcase.eq.6)then
         if(enwr(7).eq.'scrv')then
          call rhoz_reverse(isource,ipTHS,nSC,mAS,sTr,sP1,sP2,sP3,attenuation)
         else
          call rhoz(isource,ipTHS,nSC,mAS,sTr,sP1,sP2,sP3,attenuation)
         end if
         do n=-nSC,nSC
          sTr(n)=sTr(n)/hnorm
          sP1(n)=sP1(n)/hnorm
          sP2(n)=sP2(n)/hnorm
          sP3(n)=sP3(n)/hnorm
         end do
         n=1
        else
         if(b_polisite(isite)) then 
!          aTr(n)= 0.5*real(aa(1)+aa(4))-1. 
!          aP1(n)=  real(aa(2)) 
!          aP2(n)= aimag(aa(2)) 
!          aP3(n)= -0.5*real(aa(1)-aa(4))      ! ? 4.10.2015

          do n=0,nSC 
           nn=isource+4*n 
           sTr(n) =aimag(array_fr(nn+1)) 
           sTr(-n)=aimag(array_fr(nn+3)) 
           sP1(n)=  real(array_fr(nn+2)) 
           sP2(n)=aimag(array_fr(nn+2)) 
           sP3(n)= - real(array_fr(nn+1))    ! ? 4.10.2015  
           sP1(-n)=  real(array_fr(nn+4)) 
           sP2(-n)=aimag(array_fr(nn+4)) 
           sP3(-n)= - real(array_fr(nn+3))   ! ? 4.10.2015
          end do
         else 
          do n=0,nSC 
           nn=isource+2*n 
           sTr(n) =aimag(array_fr(nn+1)) 
           sTr(-n)=aimag(array_fr(nn+2)) 
          end do
          if(b_polabsorber)then
           sP1=0.;sP2=0.;sP3=0. 
          end if
         end if 
!        write(6,'(a,2i8)')'mossbau nSC,isource=',nSC,isource     
!        write(12,'(i6,2x,f12.5)') (n,sTr(n)*100.,n=-nSC,nSC,16) 
        end if
        if(b_absdetector) then 
!        ----------------------------------------------------------     
!        b_absdetector=.true.  detector at rest relative to the source  
!        -----------------------------------------------------------   
         ! this approximation is adhoc 
         do n=-nSC,nSC 
          sTr(n)=sTr(n)*detector(n)
          sP1(n)=sP1(n)*detector(n) 
          sP2(n)=sP2(n)*detector(n)
          sP3(n)=sP3(n)*detector(n)
         end do
        end if 

        npolSCAS=0 
        if (b_polsource.and.b_polabsorber) npolSCAS=1 
!       write(6,'(a,4i5)') ' npolSCAS=',npolSCAS,nAS, nSC
                                                                        
        if(nAS.gt.nSC) then 
         call convolutionAS(km,nSC,npolSCAS,yout) 
        else 
         call convolutionSC(km,nAS,npolSCAS,yout) 
        end if 
!       write(6,'(a,f10.4,i4)')'thickness,isite=',factor_thickness,isite
        do k=0,km 
         array_fr(nspdv+k)=array_fr(nspdv+k)+yout(k)*factor_thickness 
        end do 
       end if    ! factor_thickness.gt.0)
      end do     ! isite source loop 
     end do      ! incoherent fraction
!    store yout(k)*factor_thickness for each absorber device (lstruct1)
                                                                  
      nspdv=l1_put(2)+4*(nAS+1)+1 
      if(mfr1.gt.2)then 
       if(ifrcase.eq.6)then
        do lstruct1=2,mfr1 
         areafrac(lstruct1)=1.0
        end do 
       else
        h=0.
        do lstruct1=2,mfr1 
         h=h+areafrac(lstruct1)
        end do 
        do lstruct1=2,mfr1 
         areafrac(lstruct1)=areafrac(lstruct1)/h
        end do 
       end if

       do lstruct1=2,mfr1 
        nspdv=l1_put(lstruct1)+4*(nAS+1)+1 
        do k=0,km 
         array_fr(iyout+k)=array_fr(iyout+k)+                           &
                          array_fr(nspdv+k)*areafrac(lstruct1)         
        end do 
       end do     ! mfr1     
      else 
       do k=0,km 
        array_fr(iyout+k)=array_fr(iyout+k)+array_fr(nspdv+k) 
       end do 
!      do k=0,km,8                                                      
!       write(6,'(f12.5)') array_fr(iyout+k)                            
!      end do  
      end if 
!-------------------------------------------------------------          
!     end of calculation of absorber function                           
                                                                        
 1000 continue 
      deallocate(detector)
                                                                        
      return 
      END                                           
                                                                        
                                                                        
     subroutine convolutionAS_(km,nSC,npolSCAS,yout) 
     use glbconst, only: maxn,maxscrd
     implicit none
                                                                 
     integer km,nSC,npolSCAS
     integer,parameter::mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     real        sTr,sP1,sP2,sP3,aTr,aP1,aP2,aP3,sa,dumscrd 
     common/scrd/sTr(-mAS:mAS),sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),&
                 aTr(-mAS:mAS),aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),&
                 sa(-mAS:mAS),dumscrd(idumscrd)       
                  
     complex   yout(0:512) 
     real    h1,h2
     integer i,j,k                                                    
!-----------------------------------------------------------------------
!      convolution with the absorber function                           
!                                                                       
!     -nAS-------k2--------------0---------k----k2--------nAS           
!     -nSC---k2--0--k2---nSC  -nSC---k2--0--k2---nSC                    
!                                                                       
                                                                        
!     this convolution is calculated with stepwidth srw2                
!         write(6,'(a,i8)') '  -conAS--, iscn=',iscn                    
                                                                        
!       do j=-nSC/8,nSC/8                                               
!        write(6,'(i4,8e10.3)') j,(aTr((j-1)*8+i),i=1,8)                
!       end do                                                          
!       write(6,'(a,2i6)') 'convolutionAS kzlm,nSC=',kzlm,nSC           
!       write(6,'(a,i8)') 'convolutionAS npolSCAS=',npolSCAS            
!      write(6,'(4f10.3)') (sTR(i),i=-2,1)                              
!       write(6,'(i4,a,2f15.6)')                                        
!     &    (k,' sTr(k),aTr(k)=',sTr(k),aTr(k),k=-5,5)                   
                                                                        
      do i=0,2*km,2 
       h1=0. 
       h2=0. 
        do j=-nSC+1,nSC-1,2 
        h1=h1+ sTr(j)*aTr(i+j)*2. 
        h2=h2+ sTr(j)*aTr(-i+j)*2. 
        end do 
        do j=-nSC+2,nSC-2,2 
        h1=h1+ sTr(j)*aTr(i+j) 
        h2=h2+ sTr(j)*aTr(-i+j) 
        end do 
        h1=h1*2.+ sTr(-nSC)*aTr(-nSC+i)+sTr(nSC)*aTr(nSC+i) 
        h2=h2*2.+ sTr(-nSC)*aTr(-nSC-i)+sTr(nSC)*aTr(nSC-i) 
                                                                        
      if (npolSCAS.eq.1) then 
!     product   sP * aP  , Poincare vector of the source sP is already  
!     weighted by the intensity sTr                                     
                                                                        
        do j=-nSC+1,nSC-1,2 
        h1=h1+ (sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j))*4. 
        h2=h2+ (sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j))*4. 
        end do 
        do j=-nSC+2,nSC-2,2 
        h1=h1+ (sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j))*2. 
        h2=h2+ (sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j))*2. 
        end do 
        k=-nSC+i 
        h1=h1+ sP1(-nSC)*aP1(k)+sP2(-nSC)*aP2(k)+sP3(-nSC)*aP3(k) 
        k=nSC+i 
        h1=h1+ sP1(nSC)*aP1(k)+sP2(nSC)*aP2(k)+sP3(nSC)*aP3(k) 
        k=-nSC-i 
        h2=h2+ sP1(-nSC)*aP1(k)+sP2(-nSC)*aP2(k)+sP3(-nSC)*aP3(k) 
        k=nSC-i 
        h2=h2+ sP1(nSC)*aP1(k)+sP2(nSC)*aP2(k)+sP3(nSC)*aP3(k) 
       end if     ! if polarized- condition 
       yout(i/2)=cmplx(h1,h2)/3. 
      end do 
      return 
      END                                           
                                                                        
     subroutine convolutionSC(km,nAS,npolSCAS,yout) 
     use glbconst, only: maxn,maxscrd
     implicit none
                                                                  
     integer km,nAS,npolSCAS
     integer,parameter::mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     real        sTr,sP1,sP2,sP3,aTr,aP1,aP2,aP3,sa,dumscrd 
     common/scrd/sTr(-mAS:mAS),sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),&
                 aTr(-mAS:mAS),aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),&
                 sa(-mAS:mAS),dumscrd(idumscrd)       
                  
     complex   yout(0:512) 
     real    h1,h2,hi,hr
     integer i,j,k   
!    write(6,'(a,i4)') 'convolutionSC sTR,aTR,npolSCAS=',npolSCAS     
!    write(6,'(a,2i8)') 'convolutionSC nAS=',nAS                     
                                                                        
      do i=0,2*km,2 
       do j=-nAS,nAS 
        sa(j)=aTr(j)*sTr(i+j) 
       end do 
       h1=0. 
       do j=-nAS+1,nAS-1,2 
        h1=h1+ sa(j)*4. 
       end do 
       do j=-nAS+2,nAS-2,2 
        h1=h1+ sa(j)*2 
       end do 
       h1=h1+ sa(-nAS)+sa(nAS) 
       h2=0. 
       do j=-nAS+3,nAS-5,2 
        h2=h2+ sa(j)*8. 
       end do 
       do j=-nAS+2,nAS-4,2 
        h2=h2- sa(j)*8. 
       end do 
       h2=h2-4.*(sa(-nAS)+sa(nAS-2))                                    &
     &      +7.*(sa(-nAS+1)+sa(nAS-3))                                  
       hr=h1-h2/30. 
                                                                        
       do j=-nAS,nAS 
        sa(j)=aTr(j)*sTr(-i+j) 
       end do 
       h1=0. 
       do j=-nAS+1,nAS-1,2 
        h1=h1+ sa(j)*4. 
       end do 
       do j=-nAS+2,nAS-2,2 
        h1=h1+ sa(j)*2 
       end do 
       h1=h1+ sa(-nAS)+sa(nAS) 
       h2=0. 
       do j=-nAS+3,nAS-5,2 
        h2=h2+ sa(j)*8. 
       end do 
       do j=-nAS+2,nAS-4,2 
        h2=h2- sa(j)*8. 
       end do 
       h2=h2-4.*(sa(-nAS)+sa(nAS-2))                                    &
            +7.*(sa(-nAS+1)+sa(nAS-3))                                  
       hi=h1-h2/30. 
                                                                        
       if (npolSCAS.eq.1) then 
!       product   aP * sP  , Poincare vector of the source sP is already
!       weighted by the intensity sTr                                   
        do j=-nAS,nAS 
         sa(j)=aP1(j)*sP1(i+j)+aP2(j)*sP2(i+j)+aP3(j)*sP3(i+j) 
        end do 
        h1=0. 
        do j=-nAS+1,nAS-1,2 
         h1=h1+ sa(j)*4. 
        end do 
        do j=-nAS+2,nAS-2,2 
         h1=h1+ sa(j)*2 
        end do 
        h1=h1+ sa(-nAS)+sa(nAS) 
        h2=0. 
        do j=-nAS+3,nAS-5,2 
         h2=h2+ sa(j)*8. 
        end do 
        do j=-nAS+2,nAS-4,2 
         h2=h2- sa(j)*8. 
        end do 
        h2=h2-4.*(sa(-nAS)+sa(nAS-2))                                   &
             +7.*(sa(-nAS+1)+sa(nAS-3))                                 
        hr=hr+h1-h2/30. 
                                                                        
        do j=-nAS,nAS 
         sa(j)=aP1(j)*sP1(-i+j)+aP2(j)*sP2(-i+j)+aP3(j)*sP3(-i+j) 
        end do 
        h1=0. 
        do j=-nAS+1,nAS-1,2 
         h1=h1+ sa(j)*4. 
        end do 
        do j=-nAS+2,nAS-2,2 
         h1=h1+ sa(j)*2 
        end do 
        h1=h1+ sa(-nAS)+sa(nAS) 
        h2=0. 
        do j=-nAS+3,nAS-5,2 
         h2=h2+ sa(j)*8. 
        end do 
        do j=-nAS+2,nAS-4,2 
         h2=h2- sa(j)*8. 
        end do 
        h2=h2-4.*(sa(-nAS)+sa(nAS-2))                                   &
             +7.*(sa(-nAS+1)+sa(nAS-3))                                 
        hi=hi+h1-h2/30. 
       end if     ! if polarized- condition 
       k=i/2 
       yout(k)=cmplx(hi,hr)/3. 
      end do 
      return 
      END                                           
                                                                        
     subroutine convolutionAS(km,nSC,npolSCAS,yout) 
     use glbconst, only: maxn,maxscrd
     implicit none
                                                                  
     integer km,nSC,npolSCAS
     integer,parameter::mAS=4*maxn,idumscrd=maxscrd-9*(2*mAS+1)
     real        sTr,sP1,sP2,sP3,aTr,aP1,aP2,aP3,sa,dumscrd 
     common/scrd/sTr(-mAS:mAS),sP1(-mAS:mAS),sP2(-mAS:mAS),sP3(-mAS:mAS),&
                 aTr(-mAS:mAS),aP1(-mAS:mAS),aP2(-mAS:mAS),aP3(-mAS:mAS),&
                 sa(-mAS:mAS),dumscrd(idumscrd)       
                  
     complex   yout(0:512) 
     real    h1,h2,hi,hr
     integer i,j,k
!-----------------------------------------------------------------------
!      convolution with the absorber function                           
!                                                                       
!     -nAS-------k2--------------0---------k----k2--------nAS           
!     -nSC---k2--0--k2---nSC  -nSC---k2--0--k2---nSC                    
!                                                                       
                                                                        
!     this convolution is calculated with stepwidth srw2                
!         write(6,'(a,i8)') '  -conAS--, iscn=',iscn                    
                                                                        
!       do j=-nSC/8,nSC/8                                               
!        write(6,'(i4,8e10.3)') j,(aTr((j-1)*8+i),i=1,8)                
!       end do                                                          
!       write(6,'(a,2i6)') 'convolutionAS km,nSC=',km,nSC           
!       write(6,'(a,i8)') 'convolutionAS npolSCAS=',npolSCAS            
                                                               
      do i=0,2*km,2 
                                                                        
       do j=-nSC,nSC 
        sa(j)=sTr(j)*aTr(i+j) 
       end do 
       h1=0. 
       do j=-nSC+1,nSC-1,2 
        h1=h1+ sa(j)*4. 
       end do 
       do j=-nSC+2,nSC-2,2 
        h1=h1+ sa(j)*2 
       end do 
       h1=h1+ sa(-nSC)+sa(nSC) 
       h2=0. 
       do j=-nSC+3,nSC-5,2 
        h2=h2+ sa(j)*8. 
       end do 
       do j=-nSC+2,nSC-4,2 
        h2=h2- sa(j)*8. 
       end do 
       h2=h2-4.*(sa(-nSC)+sa(nSC-2))                                    &
            +7.*(sa(-nSC+1)+sa(nSC-3))                                  
       hr=h1-h2/30. 
                                                                        
       do j=-nSC,nSC 
        sa(j)=sTr(j)*aTr(-i+j) 
       end do 
       h1=0. 
       do j=-nSC+1,nSC-1,2 
        h1=h1+ sa(j)*4. 
       end do 
       do j=-nSC+2,nSC-2,2 
        h1=h1+ sa(j)*2 
       end do 
       h1=h1+ sa(-nSC)+sa(nSC) 
       h2=0. 
       do j=-nSC+3,nSC-5,2 
        h2=h2+ sa(j)*8. 
       end do 
       do j=-nSC+2,nSC-4,2 
        h2=h2- sa(j)*8. 
       end do 
       h2=h2-4.*(sa(-nSC)+sa(nSC-2))                                    &
            +7.*(sa(-nSC+1)+sa(nSC-3))                                  
       hi=h1-h2/30. 
                                                                        
       if (npolSCAS.eq.1) then 
!      product   sP * aP  , Poincare vector of the source sP is already 
!      weighted by the intensity sTr                                    
        do j=-nSC,nSC 
         sa(j)=sP1(j)*aP1(i+j)+sP2(j)*aP2(i+j)+sP3(j)*aP3(i+j) 
        end do 
        h1=0. 
        do j=-nSC+1,nSC-1,2 
         h1=h1+ sa(j)*4. 
        end do 
        do j=-nSC+2,nSC-2,2 
         h1=h1+ sa(j)*2 
        end do 
        h1=h1+ sa(-nSC)+sa(nSC) 
        h2=0. 
        do j=-nSC+3,nSC-5,2 
         h2=h2+ sa(j)*8. 
        end do 
        do j=-nSC+2,nSC-4,2 
         h2=h2- sa(j)*8. 
        end do 
        h2=h2-4.*(sa(-nSC)+sa(nSC-2))                                   &
             +7.*(sa(-nSC+1)+sa(nSC-3))                                 
        hr=hr+h1-h2/30. 
                                                                        
        do j=-nSC,nSC 
         sa(j)=sP1(j)*aP1(-i+j)+sP2(j)*aP2(-i+j)+sP3(j)*aP3(-i+j) 
        end do 
        h1=0. 
        do j=-nSC+1,nSC-1,2 
         h1=h1+ sa(j)*4. 
        end do 
        do j=-nSC+2,nSC-2,2 
         h1=h1+ sa(j)*2 
        end do 
        h1=h1+ sa(-nSC)+sa(nSC) 
        h2=0. 
        do j=-nSC+3,nSC-5,2 
         h2=h2+ sa(j)*8. 
        end do 
        do j=-nSC+2,nSC-4,2 
         h2=h2- sa(j)*8. 
        end do 
        h2=h2-4.*(sa(-nSC)+sa(nSC-2))                                   &
             +7.*(sa(-nSC+1)+sa(nSC-3))                                 
        hi=hi+h1-h2/30. 
       end if     ! if polarized- condition 
       k=i/2 
       yout(k)=cmplx(hr,hi)/3.
      end do 
                                                                        
      return 
      END                                           


      subroutine sum2spectra(info)
      use glbconst, only: maxthss,maxfr1,maxfr2,ivstrf,nwr,nrd
      use comdat,   only: ks_set,mfpt,ichanks,b_theory
      use comthe,   only: real_fr,thfk
      implicit none 
      integer,           intent(out)  :: info

      character(len=132),dimension(6):: chin,chin2
      character(len=132):: chcom,ch132,filename,querytype
      character(len=32) :: filetype,xaxis,yaxis
      character(len=16) :: exten,format
      character(len=1)  :: ch1
 
      logical b_file
      integer il,nchannel,j,k,iout,lq,npl
      real    sum,sumdiff,sint,sumth
      real, dimension(:), allocatable:: spectrum1,spectrum2,out


       npl=80

       ch1='c' 
       chcom='effi/summation' 
       querytype='summation of counts inside channel regions(c) or of 2 spectra (s)'
       call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
  
       if(ch1.eq.'c')then
        print '(a,i2)',' data set number ',ks_set
        print '(a)',' summation of counts in the data region(s)'
        sum=0. ; sumdiff=0.; sint=0. ; lq=0
        do j=2,ichanks(0),2 
         print '(a,i4,a,i4)',' from ',ichanks(j-1),' to ',ichanks(j)
         lq=lq+ichanks(j)-ichanks(j-1) 
         do k=ichanks(j-1),ichanks(j) 
          sum=sum+real_fr(mfpt+k)
          sumdiff=sumdiff+real_fr(mfpt+k)-thfk(k)
         end do 
         if(b_theory)then
          sumth=0.0
          do k=ichanks(j-1),ichanks(j) 
           sumdiff=sumdiff+real_fr(mfpt+k)-thfk(k)
           sint=sint+thfk(1)-thfk(k)
           sumth=sumth+thfk(k)           
          end do 
         end if
        end do
        print '(/,a,i12)',' number of channels in the data region=', lq        
        print '(/,a,f15.0)',' sum inside the region defined by {dr}=',sum
        print '(a,i12)',  ' average number of counts             =',int(sum/lq)
        if(b_theory)then 
         print '(a,f15.1)',' average difference exp-theo          =',sumdiff/lq
         print '(a,f15.4)',' (exp-theo)/tint                      =',sumdiff/sint
        end if
        return
       end if


      allocate(out(32))
      info=0
      chin=' '
      filename='spectrum1.dat' 
      chcom='effi/summation' 
      filetype='first spectrum - counts/channel' 
      exten='dat' 
   10 call rdfname(filetype,filename,exten,chcom,npl,nwr)
       if(exten.eq.'*')then
        deallocate(out)
        return
       end if
       inquire(file=filename,exist=b_file) 
       if(b_file) then 
        open(unit=11,file=filename                                    &
                 ,status='old'                                        &
                 ,access='sequential'                                 &
                 ,form='formatted')                                    
       else
        print'(a)','file '//TRIM(filename)//' not found' 
        goto 10 
       end if 
      
       read(11,'(a)')chin(1) ; print'(a)',TRIM(chin(1))
       read(11,'(a)')chin(2) ; print'(a)',TRIM(chin(2))
       j=index(chin(2),')')       
       format=chin(2)(1:j)

       il=1
       do while(il.le.4)
        read(11,'(a)')chin(il+2) ; print'(a)',TRIM(chin(il+2))        
        j=index(chin(il+2),'nu_channel')
        if(j.gt.0) then
         ch132=chin(il+2)
         call trlch(npl,ch132,iout,out)
         nchannel=out(1)
        else
         if(index(chin(il+2),'=').eq.0)then
          backspace(11); chin(il+2)=' '; il=5
         end if
        end if
        il=il+1
       end do

       allocate(spectrum1(nchannel),spectrum2(nchannel))


      read(11,format)(spectrum1(k),k=1,nchannel)
      read(11,'(a)')yaxis
      read(11,'(a)')xaxis
      close(unit=11)
   
      chcom='effi/summation' 
      filetype='second spectrum - counts/channel' 
      exten='dat'
      filename='spectrum2.dat'  
   20 call rdfname(filetype,filename,exten,chcom,npl,nwr)

       inquire(file=filename,exist=b_file) 
       if(b_file) then 
        open(unit=11,file=filename                                    &
                 ,status='old'                                        &
                 ,access='sequential'                                 &
                 ,form='formatted')                                    
       else
        print'(a)','file '//TRIM(filename)//' not found' 
        goto 20 
       end if 

       chin2=' '
       il=1
       do while(il.le.6)
        read(11,'(a)')chin2(il) ; print'(a)',TRIM(chin2(il))
        if(index(chin2(il),'=').eq.0.and.il.gt.3)il=7
        il=il+1
       end do
       backspace(11)

       j=index(chin2(2),')')       
       format=chin2(2)(1:j)
  
       read(11,format)(spectrum2(k), k=1,nchannel)

       do k=1,nchannel
        spectrum1(k)=spectrum1(k)+spectrum2(k) 
       end do
       close(unit=11)

      chcom='effi/summation' 
      filetype='sum of spectra - counts/channel' 
      exten='dat' 
      filename='sum.dat'
      call rdfname(filetype,filename,exten,chcom,npl,nwr)

      open(unit=11,file=filename                                    &
               ,status='unknown'                                    &
               ,access='sequential'                                 &
               ,form='formatted')                                    

      querytype='which header for the sum: [of the first spectrum]'
      ch1='y' 
      chcom='effi/sum/spectrum1_2' 
      call yesno(querytype,ch1,chcom,npl,nrd,nwr) 
      if(ch1.eq.'n')then
       chin=' '
       j=1
       do while(chin2(j).ne.' ')
        chin(j)=chin2(j)
        j=j+1
       end do  
      end if 

      querytype=' the format of the count number may not be sufficient'
      ch132=chin(2)
      chcom='effi/sum/spectrum1_2/format' 
      call askstring(querytype,ch132,chcom,npl,nwr)       
      chin(2)=ch132 
      j=index(ch132,')')
      format=ch132(1:j)
      j=1
      do while(chin(j).ne.' ')
       write(11,'(a)')TRIM(chin(j))
       j=j+1
      end do  
      write(11,format)(spectrum1(k),k=1,nchannel)
      write(11,'(a)')yaxis
      write(11,'(a)')xaxis
      write(11,'(a)')' '
      write(11,'(a)')'##'
      close(unit=11)                

      deallocate(spectrum1,spectrum2,out)
      return
      end

